'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var merge = require('lodash/merge');

var _require = require('../lib/utils'),
    _debug = _require.debug;

module.exports = function () {
  function Client() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck3.default)(this, Client);

    options.dev = options.dev || false;
    options.settings = options.settings || {};

    this.dev = options.dev;
    this.settings = options.settings;
    this.settings.public = this.settings.public || {};
  }

  (0, _createClass3.default)(Client, [{
    key: 'getSetting',
    value: function getSetting(name, defaultValue) {
      var settings = this.settings;

      var rootSetting = settings[name];
      var privateSetting = settings.private && settings.private[name];
      var publicSetting = settings.public && settings.public[name];

      if ((typeof rootSetting === 'undefined' ? 'undefined' : (0, _typeof3.default)(rootSetting)) === 'object' && !Array.isArray(rootSetting) || (typeof privateSetting === 'undefined' ? 'undefined' : (0, _typeof3.default)(privateSetting)) === 'object' && !Array.isArray(privateSetting) || (typeof publicSetting === 'undefined' ? 'undefined' : (0, _typeof3.default)(publicSetting)) === 'object' && !Array.isArray(publicSetting)) {
        return merge({}, defaultValue, publicSetting, rootSetting, privateSetting);
      } else {
        if (privateSetting !== undefined) return privateSetting;else if (rootSetting !== undefined) return rootSetting;else if (publicSetting !== undefined) return publicSetting;
        return defaultValue;
      }
    }
  }, {
    key: 'absoluteUrl',
    value: function absoluteUrl(path, options) {
      // path is optional
      if (!options && (typeof path === 'undefined' ? 'undefined' : (0, _typeof3.default)(path)) === 'object') {
        options = path;
        path = undefined;
      }
      // merge options with defaults
      options = options || {};
      options = (0, _extends3.default)({
        rootUrl: this.getSetting('rootUrl')
      }, options);

      var url = options.rootUrl;
      if (!url) {
        throw new Error('Must pass options.rootUrl or set rootUrl in the settings');
      }

      if (!/^http[s]?:\/\//i.test(url)) {
        // url starts with 'http://' or 'https://'
        url = 'http://' + url; // we will later fix to https if options.secure is set
      }

      if (!/\/$/.test(url)) {
        // url ends with '/'
        url += '/';
      }

      if (path) {
        url += path;
      }

      // turn http to https if secure option is set, and we're not talking
      // to localhost.
      if (options.secure && /^http:/.test(url) && // url starts with 'http:'
      !/http:\/\/localhost[:/]/.test(url) && // doesn't match localhost
      !/http:\/\/127\.0\.0\.1[:/]/.test(url)) {
        // or 127.0.0.1
        url = url.replace(/^http:/, 'https:');
      }

      if (options.replaceLocalhost) {
        url = url.replace(/^http:\/\/localhost([:/].*)/, 'http://127.0.0.1$1');
      }

      return url;
    }
  }, {
    key: 'captureException',
    value: function captureException(e) {
      this.debug('capture exception', e);
    }
  }, {
    key: 'debug',
    value: function debug() {
      if (this.dev && this.getSetting('debug')) {
        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _debug.apply(undefined, ['DEBUG>'].concat(args));
      }
    }
  }]);
  return Client;
}();