'use strict';

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _jsxFileName = 'init.js';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');
var PropTypes = require('prop-types');

var _require = require('react-apollo'),
    ApolloProvider = _require.ApolloProvider,
    getDataFromTree = _require.getDataFromTree;

var Head = require('next/head').default;
var compose = require('lodash/flowRight');
var filter = require('lodash/filter');
var pick = require('lodash/pick');
var map = require('lodash/map');

var _require2 = require('../lib/utils'),
    getComponentDisplayName = _require2.getComponentDisplayName,
    EJSON = _require2.EJSON,
    isServer = _require2.isServer,
    isClient = _require2.isClient;

var nprogressStyle = '#nprogress{pointer-events:none}#nprogress .bar{position:fixed;z-index:2000;top:0;left:0;width:100%;height:2px}#nprogress .peg{display:block;position:absolute;right:0px;width:100px;height:100%;opacity:1.0;-webkit-transform:rotate(3deg) translate(0px,-4px);-ms-transform:rotate(3deg) translate(0px,-4px);transform:rotate(3deg) translate(0px,-4px)}#nprogress .bar{background: #000}#nprogress .peg{box-shadow: 0 0 10px #ccc, 0 0 5px #ccc}';

var NextClient = (0, _extends3.default)({}, require('../lib/utils'), require('../lib/utils/http/client'), require('../lib/utils/reload'), require('../lib/utils/url/client'));
if (isClient) {
  window.Next = window.NextClient = NextClient;
} else {
  global.NextClient = NextClient;
}

function initApp(appOptions) {
  var Client = require('./');
  var app = new Client(appOptions);
  app.app = app;
  return app;
}

var AppConsumer = function AppConsumer(props, context) {
  return props.children(context.app);
};
AppConsumer.contextTypes = {
  app: PropTypes.object.isRequired
};
AppConsumer.propTypes = {
  children: PropTypes.func.isRequired
};

NextClient.AppConsumer = AppConsumer;

NextClient.withAppProvider = function () {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  if (options.modules && !Array.isArray(options.modules)) {
    options.modules = map(options.modules, function (mod, name) {
      if (!mod.name) mod.name = name;
      return mod;
    });
  }

  return function (ComposedComponent) {
    var WithAppProvider = function (_React$PureComponent) {
      (0, _inherits3.default)(WithAppProvider, _React$PureComponent);

      function WithAppProvider() {
        (0, _classCallCheck3.default)(this, WithAppProvider);
        return (0, _possibleConstructorReturn3.default)(this, (WithAppProvider.__proto__ || (0, _getPrototypeOf2.default)(WithAppProvider)).apply(this, arguments));
      }

      (0, _createClass3.default)(WithAppProvider, [{
        key: 'render',
        value: function render() {
          try {
            // (SSR) prepare props
            // (CSR) prepare props
            // (CSR AGAIN) prepare props
            var _props = this.props,
                initialState = _props.initialState,
                dev = _props.dev,
                settings = _props.settings,
                currentUser = _props.currentUser,
                _blank = _props._blank,
                ssr = _props.ssr,
                url = _props.url,
                other = (0, _objectWithoutProperties3.default)(_props, ['initialState', 'dev', 'settings', 'currentUser', '_blank', 'ssr', 'url']);

            // (SSR) on error render null
            // (CSR) on error render null
            // (CSR AGAIN) on error render null

            if (_blank) return null;

            // (SSR) use old app
            // (CSR) create new app with props
            // (CSR AGAIN) use old app
            if (isServer) {
              this.app = initApp({ dev: dev, settings: settings });
            } else {
              this.app = initApp({ dev: dev, settings: settings });
              if (window.app && window.app.client) {
                this.app.client = window.app.client;
              }
            }
            this.app.ssr = ssr;

            // (SSR) prepare context
            // (CSR) prepare context
            // (CSR AGAIN) prepare context
            var newContext = {
              // from initialprops
              initialState: initialState,
              dev: dev,
              settings: settings,
              currentUser: currentUser,
              ssr: ssr,
              // initial, app and server
              initial: false,
              app: this.app,
              // server: isServer && Next.servers.get(serverId),
              // url
              pathname: url.pathname,
              query: url.query,
              asPath: url.asPath

              // (SSR) run client modules
              // (CSR) run client modules
              // (CSR AGAIN) run client modules
            };this.app.debug('withAppProvider render (' + (isServer ? 'server' : 'client') + ') - ' + url.pathname);

            var modules = [].concat((0, _toConsumableArray3.default)(NextClient.appModules), (0, _toConsumableArray3.default)(options.modules || []));
            runSetupHooks(modules, this.app, newContext);

            // (SSR) run client startups
            // (CSR) run client startups
            // (CSR AGAIN) run client startups
            runStartupHooks(modules, 'beforeStartup', this.app, newContext);
            runStartupHooks(modules, 'startup', this.app, newContext);
            runStartupHooks(modules, 'afterStartup', this.app, newContext);

            // save current app
            if (isClient) {
              window.app = this.app;
            }

            // (SSR) render
            // (CSR) render
            // (CSR AGAIN) render
            var composedNewProps = (0, _extends3.default)({}, other, {
              url: url
            });

            return React.createElement(
              'div',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 394
                }
              },
              React.createElement(
                Head,
                {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 395
                  }
                },
                React.createElement('meta', {
                  name: 'viewport',
                  content: 'width=device-width, initial-scale=1',
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 396
                  }
                }),
                React.createElement(
                  'style',
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 400
                    }
                  },
                  '' + nprogressStyle
                )
              ),
              React.createElement(
                AppProvider,
                { app: this.app, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 402
                  }
                },
                React.createElement(ComposedComponent, (0, _extends3.default)({}, composedNewProps, {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 403
                  }
                }))
              )
            );
          } catch (error) {
            if (this.app && this.app.captureException) {
              this.app.captureException(error);
            }
            throw error;
          }
        }
      }], [{
        key: 'getInitialProps',
        value: function () {
          var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(ctx) {
            var initialProps, composedInitialProps, instance, currentUser, app, newContext, modules, composedNewProps;
            return _regenerator2.default.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    // (SSR INIT) ctx.ssr && ctx.initial
                    // (SSR)  ctx.ssr && !ctx.initial && isServer
                    // (CSR)  ctx.ssr && !ctx.initial && isClient
                    // (CSR INIT) !ctx.ssr && ctx.initial
                    // (CSR AGAIN) !ctx.ssr && !ctx.initial

                    // (SSR INIT) prepare initialProps
                    // (CSR INIT) prepare initialProps
                    initialProps = {
                      // (SSR INIT) 1. create new app.apolloClient, get initialState from getDataFromTree
                      // (SSR) 2. use old app.apolloClient
                      // (CSR) 3. when app not exist, create new app.apolloClient with props.initialState
                      // (CSR INIT) 4. use old app.apolloClient
                      // (CSR AGAIN) 5. when app exists, use old app.apolloClient
                      initialState: {},
                      // (SSR INIT) 1. create new app.dev
                      // (SSR) 2. use old app.dev
                      // (CSR) 3. when app not exist, create new app.dev with props.dev
                      // (CSR INIT) 4. use old app.dev
                      // (CSR AGAIN) 5. when app exists, use old app.dev
                      dev: false,
                      // (SSR INIT) 1. create new app.settings
                      // (SSR) 2. use old app.settings
                      // (CSR) 3. when app not exist, create new app.settings with props.settings
                      // (CSR INIT) 4. use old app.settings
                      // (CSR AGAIN) 5. when app exists, use old app.settings
                      settings: {},
                      // (SSR INIT) 1. when create new app, get user with req loginToken, use in modules and startups
                      // (SSR) 2. use old app
                      // (CSR) 2. when app not exist, when create new app, get user with props.user, use in modules and startups
                      // (CSR INIT) 4. use old app
                      // (CSR AGAIN) 5. when app exists, use old app
                      currentUser: null,
                      // (SSR INIT) 1. when throw error, _blank = true
                      // (SSR) 2. if props._blank, render null
                      // (CSR) 3. if props._blank, render null
                      // (CSR INIT) 4. when throw error, _blank = true
                      // (CSR AGAIN) 5. if props._blank, render null
                      _blank: false,
                      // other: helpers
                      ssr: true
                      // serverId: undefined


                      // (SSR INIT) prepare composedInitialProps
                      // (CSR INIT) prepare composedInitialProps
                    };
                    composedInitialProps = {};
                    _context.prev = 2;

                    // (SSR INIT) ssr = true, run on server
                    // (CSR INIT) ssr = false, run on browser
                    initialProps.ssr = isServer;

                    // (SSR INIT) get server
                    // (CSR INIT) get current app
                    instance = isServer ? ctx.req.server : window.app;

                    // if (isServer) {
                    //   initialProps.serverId = instance.id
                    // }

                    // (SSR INIT) get user from Fiber dynamic scope
                    // (CSR INIT) get user from current app cache

                    currentUser = null;

                    if (isServer) {
                      currentUser = ctx.req.currentUser || null;
                    } else if (instance.getCurrentUserFromCache) {
                      currentUser = instance.getCurrentUserFromCache() || null;
                    }
                    if (currentUser) {
                      initialProps.currentUser = EJSON.clone(currentUser);
                    }
                    if (initialProps.currentUser && initialProps.currentUser.services) {
                      (0, _keys2.default)(initialProps.currentUser.services).forEach(function (key) {
                        initialProps.currentUser.services[key] = {};
                      });
                    }

                    // (SSR INIT) get dev from server
                    // (CSR INIT) get dev from current app
                    initialProps.dev = instance.dev;

                    // (SSR INIT) get settings from server
                    // (CSR INIT) get settings from current app
                    initialProps.settings = {
                      public: instance.settings.public || {}

                      // (SSR INIT) create new app
                      // (CSR INIT) use old current app
                    };app = void 0;

                    if (isServer) {
                      app = initApp({
                        dev: initialProps.dev,
                        settings: initialProps.settings
                      });
                    } else {
                      app = initApp({
                        dev: initialProps.dev,
                        settings: initialProps.settings
                      });
                      if (instance && instance.client) {
                        app.client = instance.client;
                      }
                    }
                    app.ssr = initialProps.ssr;

                    // (SSR INIT) prepare context
                    // (CSR INIT) prepare context
                    newContext = (0, _extends3.default)({}, pick(initialProps, ['initialState', 'dev', 'settings', 'currentUser', 'ssr']), pick(ctx, ['pathname', 'query', 'asPath', 'req', 'res', 'jsonPageRes', 'err']), {
                      initial: true,
                      app: app,
                      server: isServer && instance

                      // (SSR INIT) run client modules
                      // (CSR INIT) run client modules
                    });
                    app.debug('withAppProvider getInitialProps (' + (isServer ? 'server' : 'client') + ') - ' + ctx.pathname);

                    modules = [].concat((0, _toConsumableArray3.default)(NextClient.appModules), (0, _toConsumableArray3.default)(options.modules || []));
                    _context.next = 19;
                    return runSetupHooks(modules, app, newContext, initialProps);

                  case 19:
                    _context.next = 21;
                    return runStartupHooks(modules, 'beforeStartup', app, newContext, initialProps);

                  case 21:
                    _context.next = 23;
                    return runStartupHooks(modules, 'startup', app, newContext, initialProps);

                  case 23:
                    _context.next = 25;
                    return runStartupHooks(modules, 'afterStartup', app, newContext, initialProps);

                  case 25:
                    if (!ComposedComponent.getInitialProps) {
                      _context.next = 29;
                      break;
                    }

                    _context.next = 28;
                    return ComposedComponent.getInitialProps(newContext);

                  case 28:
                    composedInitialProps = _context.sent;

                  case 29:
                    if (!isServer) {
                      _context.next = 44;
                      break;
                    }

                    composedNewProps = (0, _extends3.default)({}, composedInitialProps, {
                      // Provide the `url` prop data in case a graphql query uses it
                      url: {
                        query: ctx.query,
                        pathname: ctx.pathname,
                        asPath: ctx.asPath
                      }
                    });
                    _context.prev = 31;
                    _context.next = 34;
                    return getDataFromTree(React.createElement(
                      AppProvider,
                      { app: app, __source: {
                          fileName: _jsxFileName,
                          lineNumber: 252
                        }
                      },
                      React.createElement(ComposedComponent, (0, _extends3.default)({}, composedNewProps, {
                        __source: {
                          fileName: _jsxFileName,
                          lineNumber: 253
                        }
                      }))
                    ));

                  case 34:
                    _context.next = 40;
                    break;

                  case 36:
                    _context.prev = 36;
                    _context.t0 = _context['catch'](31);

                    console.log(_context.t0);
                    app.captureException(_context.t0);

                  case 40:

                    Head.rewind();

                    try {
                      initialProps.initialState = app.client.extract();
                    } catch (error) {
                      app.captureException(error);
                    }

                    // (CSR INIT) get initialState from current app
                    _context.next = 45;
                    break;

                  case 44:
                    try {
                      initialProps.initialState = app.client.extract();
                    } catch (error) {
                      app.captureException(error);
                    }

                  case 45:

                    // (SSR INIT) get settings again
                    // (CSR INIT) get settings again
                    initialProps.settings = {
                      public: app.settings.public || {}
                    };
                    _context.next = 52;
                    break;

                  case 48:
                    _context.prev = 48;
                    _context.t1 = _context['catch'](2);

                    // (SSR INIT) on error, log
                    // (CSR INIT) on error, log, set _blank, try reload
                    console.log('> getInitialProps error (' + (isServer ? 'server' : 'client') + ')', _context.t1);
                    if (isClient) {
                      initialProps._blank = true;
                      console.log('> browser reload!!!!!');
                      window.location.reload();
                    }

                  case 52:
                    return _context.abrupt('return', (0, _extends3.default)({}, initialProps, composedInitialProps));

                  case 53:
                  case 'end':
                    return _context.stop();
                }
              }
            }, _callee, this, [[2, 48], [31, 36]]);
          }));

          function getInitialProps(_x2) {
            return _ref.apply(this, arguments);
          }

          return getInitialProps;
        }()
      }]);
      return WithAppProvider;
    }(React.PureComponent);

    WithAppProvider.displayName = 'WithAppProvider(' + getComponentDisplayName(ComposedComponent) + ')';


    return WithAppProvider;
  };
};

var AppProvider = function (_React$PureComponent2) {
  (0, _inherits3.default)(AppProvider, _React$PureComponent2);

  function AppProvider() {
    (0, _classCallCheck3.default)(this, AppProvider);
    return (0, _possibleConstructorReturn3.default)(this, (AppProvider.__proto__ || (0, _getPrototypeOf2.default)(AppProvider)).apply(this, arguments));
  }

  (0, _createClass3.default)(AppProvider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        app: this.props.app,
        Components: this.props.app.components,
        ssr: !!this.props.app.ssr,
        client: this.props.app.client,
        settings: this.props.app.settings
      };
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement(
        ApolloProvider,
        { client: this.props.app.client, __source: {
            fileName: _jsxFileName,
            lineNumber: 441
          }
        },
        this.props.children
      );
    }
  }]);
  return AppProvider;
}(React.PureComponent);

AppProvider.childContextTypes = {
  app: PropTypes.object,
  Components: PropTypes.object,
  ssr: PropTypes.bool,
  client: PropTypes.object,
  settings: PropTypes.object
};


function runSetupHooks(modules, app, context, initialProps) {
  var setupModules = filter(modules, 'setup');
  app.debug('client setup, total: ' + setupModules.length);
  var i = 1;
  while (setupModules.length) {
    var setupModule = setupModules.shift();
    app.debug(i++ + ': ' + (setupModule.name || '[no name]') + ' setup');
    try {
      setupModule.setup.call(app, context, initialProps);
    } catch (error) {
      app.debug('Exception in client setup:', error && error.stack || error);
      app.captureException(error);
    }
  }
}

function runStartupHooks(modules, type, app, context, initialProps) {
  var startupModules = filter(modules, type);
  app.debug('client ' + type + ', total: ' + startupModules.length);
  var i = 1;
  while (startupModules.length) {
    var startupModule = startupModules.shift();
    app.debug(i++ + ': ' + (startupModule.name || '[no name]') + ' ' + type);
    try {
      startupModule[type].call(app, context, initialProps);
    } catch (error) {
      app.debug('Exception in client ' + type + ':', error && error.stack || error);
      app.captureException(error);
    }
  }
}

if (isClient) {
  var Router = require('next/router').default;
  var NProgress = require('nprogress');

  NProgress.configure({ showSpinner: false });

  Router.ready(function () {
    Router.router.events.on('routeChangeStart', function () {
      NProgress.start();
    });
    Router.router.events.on('routeChangeComplete', function () {
      NProgress.done();
    });
    Router.router.events.on('routeChangeError', function () {
      NProgress.done();
    });
  });
}

NextClient.appModules = [];
NextClient.addAppModule = function (name, obj) {
  if ((typeof name === 'undefined' ? 'undefined' : (0, _typeof3.default)(name)) === 'object') {
    obj = name;
    name = undefined;
  }
  if (name && typeof name === 'string') {
    obj.name = name;
  }
  NextClient.appModules.push(obj);
};

NextClient.compose = compose;

module.exports = NextClient;