'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

// Login handler for resume tokens.
var defaultResumeLoginHandler = function () {
  var _ref24 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee24(accounts, options) {
    var hashedToken, user, oldUnhashedStyleToken, token, tokenExpires;
    return _regenerator2.default.wrap(function _callee24$(_context24) {
      while (1) {
        switch (_context24.prev = _context24.next) {
          case 0:
            if (options.resume) {
              _context24.next = 2;
              break;
            }

            return _context24.abrupt('return', undefined);

          case 2:

            check(options.resume, String);

            hashedToken = accounts._hashLoginToken(options.resume);

            // First look for just the new-style hashed login token, to avoid
            // sending the unhashed token to the database in a query if we don't
            // need to.

            _context24.next = 6;
            return accounts.users.findOne({
              'services.resume.loginTokens.hashedToken': hashedToken
            });

          case 6:
            user = _context24.sent;

            if (user) {
              _context24.next = 11;
              break;
            }

            _context24.next = 10;
            return accounts.users.findOne({
              $or: [{ 'services.resume.loginTokens.hashedToken': hashedToken }, { 'services.resume.loginTokens.token': options.resume }]
            });

          case 10:
            user = _context24.sent;

          case 11:
            if (user) {
              _context24.next = 13;
              break;
            }

            return _context24.abrupt('return', {
              error: new AppError(403, "You've been logged out by the server. Please log in again.")
            });

          case 13:
            token = find(user.services.resume.loginTokens, function (token) {
              return token.hashedToken === hashedToken;
            });

            if (token) {
              oldUnhashedStyleToken = false;
            } else {
              token = find(user.services.resume.loginTokens, function (token) {
                return token.token === options.resume;
              });
              oldUnhashedStyleToken = true;
            }

            tokenExpires = accounts._tokenExpiration(token.when);

            if (!(new Date() >= tokenExpires)) {
              _context24.next = 18;
              break;
            }

            return _context24.abrupt('return', {
              userId: user._id,
              error: new AppError(403, 'Your session has expired. Please log in again.')
            });

          case 18:
            if (!oldUnhashedStyleToken) {
              _context24.next = 23;
              break;
            }

            _context24.next = 21;
            return accounts.users.update({
              _id: user._id,
              'services.resume.loginTokens.token': options.resume
            }, {
              $addToSet: {
                'services.resume.loginTokens': {
                  hashedToken: hashedToken,
                  when: token.when
                }
              }
            });

          case 21:
            _context24.next = 23;
            return accounts.users.update(user._id, {
              $pull: {
                'services.resume.loginTokens': { token: options.resume }
              }
            });

          case 23:
            return _context24.abrupt('return', {
              userId: user._id,
              stampedLoginToken: {
                token: options.resume,
                when: token.when
              }
            });

          case 24:
          case 'end':
            return _context24.stop();
        }
      }
    }, _callee24, this);
  }));

  return function defaultResumeLoginHandler(_x45, _x46) {
    return _ref24.apply(this, arguments);
  };
}();

// (Also used by Meteor Accounts server and tests).
//


//
/// TOKEN EXPIRATION
//

var expirePasswordToken = function () {
  var _ref25 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee25(accounts, oldestValidDate, tokenFilter, userId) {
    var userFilter, resetRangeOr, expireFilter;
    return _regenerator2.default.wrap(function _callee25$(_context25) {
      while (1) {
        switch (_context25.prev = _context25.next) {
          case 0:
            userFilter = userId ? { _id: userId } : {};
            resetRangeOr = {
              $or: [{ 'services.password.reset.when': { $lt: oldestValidDate } }, { 'services.password.reset.when': { $lt: +oldestValidDate } }]
            };
            expireFilter = { $and: [tokenFilter, resetRangeOr] };
            _context25.next = 5;
            return accounts.users.update((0, _extends3.default)({}, userFilter, expireFilter), {
              $unset: {
                'services.password.reset': ''
              }
            }, { multi: true });

          case 5:
          case 'end':
            return _context25.stop();
        }
      }
    }, _callee25, this);
  }));

  return function expirePasswordToken(_x47, _x48, _x49, _x50) {
    return _ref25.apply(this, arguments);
  };
}();

// Deletes expired tokens from the database and closes all open connections
// associated with these tokens.
//
// Exported for tests. Also, the arguments are only used by
// tests. oldestValidDate is simulate expiring tokens without waiting
// for them to actually expire. userId is used by tests to only expire
// tokens for the test user.


var setupUsersCollection = function () {
  var _ref32 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee32(collection) {
    return _regenerator2.default.wrap(function _callee32$(_context32) {
      while (1) {
        switch (_context32.prev = _context32.next) {
          case 0:
            _context32.next = 2;
            return collection._ensureIndex('username', { unique: 1, sparse: 1 });

          case 2:
            _context32.next = 4;
            return collection._ensureIndex('emails.address', { unique: 1, sparse: 1 });

          case 4:
            _context32.next = 6;
            return collection._ensureIndex('services.resume.loginTokens.hashedToken', {
              unique: 1,
              sparse: 1
            });

          case 6:
            _context32.next = 8;
            return collection._ensureIndex('services.resume.loginTokens.token', {
              unique: 1,
              sparse: 1
            });

          case 8:
            _context32.next = 10;
            return collection._ensureIndex('services.resume.loginTokens.when', {
              sparse: 1
            });

          case 10:
            _context32.next = 12;
            return collection._ensureIndex('services.password.reset.when', { sparse: 1 });

          case 12:
          case 'end':
            return _context32.stop();
        }
      }
    }, _callee32, this);
  }));

  return function setupUsersCollection(_x62) {
    return _ref32.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// meteor/packages/accounts-base/accounts_server.js
// a638475a61cc567ad7e79fb1610a59e0cc9eb653

/* eslint-disable standard/no-callback-literal */

var crypto = require('crypto');
var toArray = require('lodash/toArray');
var extend = require('lodash/extend');
var omit = require('lodash/omit');
var find = require('lodash/find');
var has = require('lodash/has');
var clone = require('lodash/clone');
var each = require('lodash/each');
var every = require('lodash/every');
var isEmpty = require('lodash/isEmpty');
var isString = require('lodash/isString');
var isFunction = require('lodash/isFunction');

var _require = require('../../utils'),
    Hook = _require.Hook,
    EJSON = _require.EJSON,
    check = _require.check,
    Random = _require.Random,
    AppError = _require.AppError,
    escapeRegExp = _require.escapeRegExp,
    Timers = _require.Timers;

var _require2 = require('./accounts_common'),
    AccountsCommon = _require2.AccountsCommon,
    EXPIRE_TOKENS_INTERVAL_MS = _require2.EXPIRE_TOKENS_INTERVAL_MS;

/**
 * @summary Constructor for the `Accounts` namespace on the server.
 * @locus Server
 * @class AccountsServer
 * @extends AccountsCommon
 * @instancename accountsServer
 * @param {Object} server A server object such as `Meteor.server`.
 */


var AccountsServer = function (_AccountsCommon) {
  (0, _inherits3.default)(AccountsServer, _AccountsCommon);

  // Note that this constructor is less likely to be instantiated multiple
  // times than the `AccountsClient` constructor, because a single server
  // can provide only one set of methods.
  function AccountsServer(server) {
    (0, _classCallCheck3.default)(this, AccountsServer);

    var _this = (0, _possibleConstructorReturn3.default)(this, (AccountsServer.__proto__ || (0, _getPrototypeOf2.default)(AccountsServer)).call(this));

    _this.server = server;

    _this.users = _this.server.createCollection('Users');

    // Set up the server's methods, as if by calling Meteor.methods.
    _this._initServerMethods();

    // list of all registered handlers.
    _this._loginHandlers = [];

    setupUsersCollection(_this.users);
    setupDefaultLoginHandlers(_this);
    setExpireTokensInterval(_this);

    _this._validateLoginHook = new Hook();
    _this._validateNewUserHooks = [defaultValidateNewUserHook.bind(_this)];
    return _this;
  }

  //
  /// LOGIN HOOKS
  //

  /**
   * @summary Validate login attempts.
   * @locus Server
   * @param {Function} func Called whenever a login is attempted (either successful or unsuccessful).  A login can be aborted by returning a falsy value or throwing an exception.
   */


  (0, _createClass3.default)(AccountsServer, [{
    key: 'validateLoginAttempt',
    value: function validateLoginAttempt(func) {
      // Exceptions inside the hook callback are passed up to us.
      return this._validateLoginHook.register(func);
    }

    /**
     * @summary Set restrictions on new user creation.
     * @locus Server
     * @param {Function} func Called whenever a new user is created. Takes the new user object, and returns true to allow the creation or false to abort.
     */

  }, {
    key: 'validateNewUser',
    value: function validateNewUser(func) {
      this._validateNewUserHooks.push(func);
    }

    //
    /// CREATE USER HOOKS
    //

    /**
     * @summary Customize new user creation.
     * @locus Server
     * @param {Function} func Called whenever a new user is created. Return the new user object, or throw an `Error` to abort the creation.
     */

  }, {
    key: 'onCreateUser',
    value: function onCreateUser(func) {
      if (this._onCreateUserHook) {
        throw new Error('Can only call onCreateUser once');
      }

      this._onCreateUserHook = func;
    }
  }]);
  return AccountsServer;
}(AccountsCommon);

var Ap = AccountsServer.prototype;

// Give each login hook callback a fresh cloned copy of the attempt
// object, but don't clone the connection.
//
function cloneAttempt(attempt) {
  var clonedAttempt = EJSON.clone(attempt);
  return clonedAttempt;
}

Ap._validateLogin = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(attempt, context) {
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return this._validateLoginHook.eachAsync(function () {
              var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(callback) {
                var ret;
                return _regenerator2.default.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.prev = 0;
                        _context.next = 3;
                        return callback(cloneAttempt(attempt), context);

                      case 3:
                        ret = _context.sent;
                        _context.next = 11;
                        break;

                      case 6:
                        _context.prev = 6;
                        _context.t0 = _context['catch'](0);

                        attempt.allowed = false;
                        // XXX this means the last thrown error overrides previous error
                        // messages. Maybe this is surprising to users and we should make
                        // overriding errors more explicit. (see
                        // https://github.com/meteor/meteor/issues/1960)
                        attempt.error = _context.t0;
                        return _context.abrupt('return', true);

                      case 11:
                        if (!ret) {
                          attempt.allowed = false;
                          // don't override a specific error provided by a previous
                          // validator or the initial attempt (eg "incorrect password").
                          if (!attempt.error) {
                            attempt.error = new AppError(403, 'Login forbidden');
                          }
                        }
                        return _context.abrupt('return', true);

                      case 13:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, this, [[0, 6]]);
              }));

              return function (_x3) {
                return _ref2.apply(this, arguments);
              };
            }());

          case 2:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

Ap._successfulLogin = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(attempt, context) {
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return this._onLoginHook.eachAsync(function () {
              var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(callback) {
                return _regenerator2.default.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        _context3.next = 2;
                        return callback(cloneAttempt(attempt), context);

                      case 2:
                        return _context3.abrupt('return', true);

                      case 3:
                      case 'end':
                        return _context3.stop();
                    }
                  }
                }, _callee3, this);
              }));

              return function (_x6) {
                return _ref4.apply(this, arguments);
              };
            }());

          case 2:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function (_x4, _x5) {
    return _ref3.apply(this, arguments);
  };
}();

Ap._failedLogin = function () {
  var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(attempt, context) {
    return _regenerator2.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return this._onLoginFailureHook.eachAsync(function () {
              var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(callback) {
                return _regenerator2.default.wrap(function _callee5$(_context5) {
                  while (1) {
                    switch (_context5.prev = _context5.next) {
                      case 0:
                        _context5.next = 2;
                        return callback(cloneAttempt(attempt), context);

                      case 2:
                        return _context5.abrupt('return', true);

                      case 3:
                      case 'end':
                        return _context5.stop();
                    }
                  }
                }, _callee5, this);
              }));

              return function (_x9) {
                return _ref6.apply(this, arguments);
              };
            }());

          case 2:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));

  return function (_x7, _x8) {
    return _ref5.apply(this, arguments);
  };
}();

Ap._successfulLogout = function () {
  var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8(userId, context) {
    var user;
    return _regenerator2.default.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            _context8.t0 = userId;

            if (!_context8.t0) {
              _context8.next = 5;
              break;
            }

            _context8.next = 4;
            return this.users.findOne(userId);

          case 4:
            _context8.t0 = _context8.sent;

          case 5:
            user = _context8.t0;
            _context8.next = 8;
            return this._onLogoutHook.eachAsync(function () {
              var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(callback) {
                return _regenerator2.default.wrap(function _callee7$(_context7) {
                  while (1) {
                    switch (_context7.prev = _context7.next) {
                      case 0:
                        _context7.next = 2;
                        return callback({ user: user }, context);

                      case 2:
                        return _context7.abrupt('return', true);

                      case 3:
                      case 'end':
                        return _context7.stop();
                    }
                  }
                }, _callee7, this);
              }));

              return function (_x12) {
                return _ref8.apply(this, arguments);
              };
            }());

          case 8:
          case 'end':
            return _context8.stop();
        }
      }
    }, _callee8, this);
  }));

  return function (_x10, _x11) {
    return _ref7.apply(this, arguments);
  };
}();

//
/// LOGIN METHODS
//

// Login methods return to the client an object containing these
// fields when the user was logged in successfully:
//
//   id: userId
//   token: *
//   tokenExpires: *
//
// tokenExpires is optional and intends to provide a hint to the
// client as to when the token will expire. If not provided, the
// client will call Accounts._tokenExpiration, passing it the date
// that it received the token.
//
// The login method will throw an error back to the client if the user
// failed to log in.
//
//
// Login handlers and service specific login methods such as
// `createUser` internally return a `result` object containing these
// fields:
//
//   type:
//     optional string; the service name, overrides the handler
//     default if present.
//
//   error:
//     exception; if the user is not allowed to login, the reason why.
//
//   userId:
//     string; the user id of the user attempting to login (if
//     known), required for an allowed login.
//
//   options:
//     optional object merged into the result returned by the login
//     method; used by HAMK from SRP.
//
//   stampedLoginToken:
//     optional object with `token` and `when` indicating the login
//     token is already present in the database, returned by the
//     "resume" login handler.
//
// For convenience, login methods can also throw an exception, which
// is converted into an {error} result.  However, if the id of the
// user attempting the login is known, a {userId, error} result should
// be returned instead since the user id is not captured when an
// exception is thrown.
//
// This internal `result` object is automatically converted into the
// public {id, token, tokenExpires} object returned to the client.

// Try a login method, converting thrown exceptions into an {error}
// result.  The `type` argument is a default, inserted into the result
// object if not explicitly returned.
//
var tryLoginMethod = function () {
  var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9(type, fn) {
    var result;
    return _regenerator2.default.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            _context9.prev = 0;
            _context9.next = 3;
            return fn();

          case 3:
            result = _context9.sent;
            _context9.next = 9;
            break;

          case 6:
            _context9.prev = 6;
            _context9.t0 = _context9['catch'](0);

            result = { error: _context9.t0 };

          case 9:

            if (result && !result.type && type) {
              result.type = type;
            }

            return _context9.abrupt('return', result);

          case 11:
          case 'end':
            return _context9.stop();
        }
      }
    }, _callee9, this, [[0, 6]]);
  }));

  return function tryLoginMethod(_x13, _x14) {
    return _ref9.apply(this, arguments);
  };
}();

// Log in a user on a connection.
//
// We use the method invocation to set the user id on the connection,
// not the connection object directly. setUserId is tied to methods to
// enforce clear ordering of method application (using wait methods on
// the client, and a no setUserId after unblock restriction on the
// server)
//
// The `stampedLoginToken` parameter is optional.  When present, it
// indicates that the login token has already been inserted into the
// database and doesn't need to be inserted again.  (It's used by the
// "resume" login handler).
Ap._loginUser = function () {
  var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee10(userId, stampedLoginToken) {
    var self;
    return _regenerator2.default.wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            self = this;

            if (stampedLoginToken) {
              _context10.next = 5;
              break;
            }

            stampedLoginToken = self._generateStampedLoginToken();
            _context10.next = 5;
            return self._insertLoginToken(userId, stampedLoginToken);

          case 5:
            return _context10.abrupt('return', {
              id: userId,
              token: stampedLoginToken.token,
              tokenExpires: self._tokenExpiration(stampedLoginToken.when)
            });

          case 6:
          case 'end':
            return _context10.stop();
        }
      }
    }, _callee10, this);
  }));

  return function (_x15, _x16) {
    return _ref10.apply(this, arguments);
  };
}();

// After a login method has completed, call the login hooks.  Note
// that `attemptLogin` is called for *all* login attempts, even ones
// which aren't successful (such as an invalid password, etc).
//
// If the login is allowed and isn't aborted by a validate login hook
// callback, log in the user.
//
Ap._attemptLogin = function () {
  var _ref11 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee11(methodName, methodArgs) {
    var context = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var result = arguments[3];
    var user, attempt, ret;
    return _regenerator2.default.wrap(function _callee11$(_context11) {
      while (1) {
        switch (_context11.prev = _context11.next) {
          case 0:
            if (result) {
              _context11.next = 2;
              break;
            }

            throw new Error('result is required');

          case 2:
            if (!(!result.userId && !result.error)) {
              _context11.next = 4;
              break;
            }

            throw new Error('A login method must specify a userId or an error');

          case 4:
            if (!result.userId) {
              _context11.next = 8;
              break;
            }

            _context11.next = 7;
            return this.users.findOne(result.userId);

          case 7:
            user = _context11.sent;

          case 8:
            attempt = {
              type: result.type || 'unknown',
              allowed: !!(result.userId && !result.error),
              methodName: methodName,
              methodArguments: toArray(methodArgs)
            };

            if (result.error) {
              attempt.error = result.error;
            }
            if (user) {
              attempt.user = user;
            }

            // _validateLogin may mutate `attempt` by adding an error and changing allowed
            // to false, but that's the only change it can make (and the user's callbacks
            // only get a clone of `attempt`).
            _context11.next = 13;
            return this._validateLogin(attempt, context);

          case 13:
            if (!attempt.allowed) {
              _context11.next = 26;
              break;
            }

            _context11.t0 = extend;
            _context11.next = 17;
            return this._loginUser(result.userId, result.stampedLoginToken);

          case 17:
            _context11.t1 = _context11.sent;
            _context11.t2 = result.options || {};
            ret = (0, _context11.t0)(_context11.t1, _context11.t2);

            ret.type = attempt.type;
            _context11.next = 23;
            return this._successfulLogin(attempt, context);

          case 23:
            return _context11.abrupt('return', ret);

          case 26:
            _context11.next = 28;
            return this._failedLogin(attempt, context);

          case 28:
            throw attempt.error;

          case 29:
          case 'end':
            return _context11.stop();
        }
      }
    }, _callee11, this);
  }));

  return function (_x18, _x19) {
    return _ref11.apply(this, arguments);
  };
}();

// All service specific login methods should go through this function.
// Ensure that thrown exceptions are caught and that login hook
// callbacks are still called.
//
Ap._loginMethod = function () {
  var _ref12 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee12(methodName, methodArgs, context, type, fn) {
    return _regenerator2.default.wrap(function _callee12$(_context12) {
      while (1) {
        switch (_context12.prev = _context12.next) {
          case 0:
            _context12.t0 = this;
            _context12.t1 = methodName;
            _context12.t2 = methodArgs;
            _context12.t3 = context;
            _context12.next = 6;
            return tryLoginMethod(type, fn);

          case 6:
            _context12.t4 = _context12.sent;
            return _context12.abrupt('return', _context12.t0._attemptLogin.call(_context12.t0, _context12.t1, _context12.t2, _context12.t3, _context12.t4));

          case 8:
          case 'end':
            return _context12.stop();
        }
      }
    }, _callee12, this);
  }));

  return function (_x20, _x21, _x22, _x23, _x24) {
    return _ref12.apply(this, arguments);
  };
}();

//
/// LOGIN HANDLERS
//

// The main entry point for auth packages to hook in to login.
//
// A login handler is a login method which can return `undefined` to
// indicate that the login request is not handled by this handler.
//
// @param name {String} Optional.  The service name, used by default
// if a specific service name isn't returned in the result.
//
// @param handler {Function} A function that receives an options object
// (as passed as an argument to the `login` method) and returns one of:
// - `undefined`, meaning don't handle
// - a login method result object

Ap.registerLoginHandler = function (name, handler) {
  if (!handler) {
    handler = name;
    name = null;
  }

  this._loginHandlers.push({
    name: name,
    handler: handler
  });
};

// Checks a user's credentials against all the registered login
// handlers, and returns a login token if the credentials are valid. It
// is like the login method, except that it doesn't set the logged-in
// user on the connection. Throws a Meteor.Error if logging in fails,
// including the case where none of the login handlers handled the login
// request. Otherwise, returns {id: userId, token: *, tokenExpires: *}.
//
// For example, if you want to login with a plaintext password, `options` could be
//   { user: { username: <username> }, password: <password> }, or
//   { user: { email: <email> }, password: <password> }.

// Try all of the registered login handlers until one of them doesn't
// return `undefined`, meaning it handled this call to `login`. Return
// that return value.
Ap._runLoginHandlers = function () {
  var _ref13 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee14(options) {
    var i, handler, result;
    return _regenerator2.default.wrap(function _callee14$(_context14) {
      while (1) {
        switch (_context14.prev = _context14.next) {
          case 0:
            i = 0;

          case 1:
            if (!(i < this._loginHandlers.length)) {
              _context14.next = 13;
              break;
            }

            handler = this._loginHandlers[i];
            _context14.next = 5;
            return tryLoginMethod(handler.name, (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee13() {
              return _regenerator2.default.wrap(function _callee13$(_context13) {
                while (1) {
                  switch (_context13.prev = _context13.next) {
                    case 0:
                      return _context13.abrupt('return', handler.handler.call(this, options));

                    case 1:
                    case 'end':
                      return _context13.stop();
                  }
                }
              }, _callee13, this);
            })));

          case 5:
            result = _context14.sent;

            if (!result) {
              _context14.next = 8;
              break;
            }

            return _context14.abrupt('return', result);

          case 8:
            if (!(result !== undefined)) {
              _context14.next = 10;
              break;
            }

            throw new AppError(400, 'A login handler should return a result or undefined');

          case 10:
            ++i;
            _context14.next = 1;
            break;

          case 13:
            return _context14.abrupt('return', {
              type: null,
              error: new AppError(400, 'Unrecognized options for login request')
            });

          case 14:
          case 'end':
            return _context14.stop();
        }
      }
    }, _callee14, this);
  }));

  return function (_x25) {
    return _ref13.apply(this, arguments);
  };
}();

// Deletes the given loginToken from the database.
//
// For new-style hashed token, this will cause all connections
// associated with the token to be closed.
//
// Any connections associated with old-style unhashed tokens will be
// in the process of becoming associated with hashed tokens and then
// they'll get closed.
Ap.destroyToken = function () {
  var _ref15 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee15(userId, loginToken) {
    return _regenerator2.default.wrap(function _callee15$(_context15) {
      while (1) {
        switch (_context15.prev = _context15.next) {
          case 0:
            _context15.next = 2;
            return this.users.update(userId, {
              $pull: {
                'services.resume.loginTokens': {
                  $or: [{ hashedToken: loginToken }, { token: loginToken }]
                }
              }
            });

          case 2:
          case 'end':
            return _context15.stop();
        }
      }
    }, _callee15, this);
  }));

  return function (_x26, _x27) {
    return _ref15.apply(this, arguments);
  };
}();

Ap._initServerMethods = function () {
  // The methods created in this function need to be created here so that
  // this variable is available in their scope.
  var accounts = this;

  // This object will be populated with methods and then passed to
  // accounts._server.methods further below.
  var methods = {};

  // @returns {Object|null}
  //   If successful, returns {token: reconnectToken, id: userId}
  //   If unsuccessful (for example, if the user closed the oauth login popup),
  //     throws an error describing the reason
  methods.login = function () {
    var _ref16 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee16(options, context) {
      var result;
      return _regenerator2.default.wrap(function _callee16$(_context16) {
        while (1) {
          switch (_context16.prev = _context16.next) {
            case 0:
              // Login handlers should really also check whatever field they look at in
              // options, but we don't enforce it.
              check(options, Object);

              _context16.next = 3;
              return accounts._runLoginHandlers(options);

            case 3:
              result = _context16.sent;
              return _context16.abrupt('return', accounts._attemptLogin('login', [options], context, result));

            case 5:
            case 'end':
              return _context16.stop();
          }
        }
      }, _callee16, this);
    }));

    return function (_x28, _x29) {
      return _ref16.apply(this, arguments);
    };
  }();

  methods.logout = function () {
    var _ref17 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee17(userId, token, context) {
      var hashedToken;
      return _regenerator2.default.wrap(function _callee17$(_context17) {
        while (1) {
          switch (_context17.prev = _context17.next) {
            case 0:
              if (!(token && userId)) {
                _context17.next = 4;
                break;
              }

              hashedToken = accounts._hashLoginToken(token);
              _context17.next = 4;
              return accounts.destroyToken(userId, hashedToken);

            case 4:
              _context17.next = 6;
              return accounts._successfulLogout(userId, context);

            case 6:
            case 'end':
              return _context17.stop();
          }
        }
      }, _callee17, this);
    }));

    return function (_x30, _x31, _x32) {
      return _ref17.apply(this, arguments);
    };
  }();

  // Generates a new login token with the same expiration as the
  // connection's current token and saves it to the database. Associates
  // the connection with this new token and returns it. Throws an error
  // if called on a connection that isn't logged in.
  //
  // @returns Object
  //   If successful, returns { token: <new token>, id: <user id>,
  //   tokenExpires: <expiration date> }.
  methods.getNewToken = function () {
    var _ref18 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee18(userId, currentToken) {
      var user, currentHashedToken, currentStampedToken, newStampedToken;
      return _regenerator2.default.wrap(function _callee18$(_context18) {
        while (1) {
          switch (_context18.prev = _context18.next) {
            case 0:
              _context18.next = 2;
              return accounts.users.findOne(userId, {
                fields: { 'services.resume.loginTokens': 1 }
              });

            case 2:
              user = _context18.sent;

              if (!(!userId || !user)) {
                _context18.next = 5;
                break;
              }

              throw new AppError('You are not logged in.');

            case 5:
              // Be careful not to generate a new token that has a later
              // expiration than the curren token. Otherwise, a bad guy with a
              // stolen token could use this method to stop his stolen token from
              // ever expiring.
              currentHashedToken = accounts._hashLoginToken(currentToken);
              currentStampedToken = find(user.services.resume.loginTokens, function (stampedToken) {
                return stampedToken.hashedToken === currentHashedToken;
              });

              if (currentStampedToken) {
                _context18.next = 9;
                break;
              }

              throw new AppError('Invalid login token');

            case 9:
              newStampedToken = accounts._generateStampedLoginToken();

              newStampedToken.when = currentStampedToken.when;
              _context18.next = 13;
              return accounts._insertLoginToken(userId, newStampedToken);

            case 13:
              return _context18.abrupt('return', accounts._loginUser(userId, newStampedToken));

            case 14:
            case 'end':
              return _context18.stop();
          }
        }
      }, _callee18, this);
    }));

    return function (_x33, _x34) {
      return _ref18.apply(this, arguments);
    };
  }();

  // Removes all tokens except the token associated with the current
  // connection. Throws an error if the connection is not logged
  // in. Returns nothing on success.
  methods.removeOtherTokens = function () {
    var _ref19 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee19(userId, currentToken) {
      var currentHashedToken;
      return _regenerator2.default.wrap(function _callee19$(_context19) {
        while (1) {
          switch (_context19.prev = _context19.next) {
            case 0:
              if (userId) {
                _context19.next = 2;
                break;
              }

              throw new AppError('You are not logged in.');

            case 2:
              currentHashedToken = accounts._hashLoginToken(currentToken);
              _context19.next = 5;
              return accounts.users.update(userId, {
                $pull: {
                  'services.resume.loginTokens': {
                    hashedToken: { $ne: currentHashedToken }
                  }
                }
              });

            case 5:
            case 'end':
              return _context19.stop();
          }
        }
      }, _callee19, this);
    }));

    return function (_x35, _x36) {
      return _ref19.apply(this, arguments);
    };
  }();

  this.server.addMethods(methods);
};

//
/// RECONNECT TOKENS
//
/// support reconnecting using a meteor login token

Ap._hashLoginToken = function (loginToken) {
  var hash = crypto.createHash('sha256');
  hash.update(loginToken);
  return hash.digest('base64');
};

// {token, when} => {hashedToken, when}
Ap._hashStampedToken = function (stampedToken) {
  return extend(omit(stampedToken, 'token'), {
    hashedToken: this._hashLoginToken(stampedToken.token)
  });
};

// Using $addToSet avoids getting an index error if another client
// logging in simultaneously has already inserted the new hashed
// token.
Ap._insertHashedLoginToken = function () {
  var _ref20 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee20(userId, hashedToken, query) {
    return _regenerator2.default.wrap(function _callee20$(_context20) {
      while (1) {
        switch (_context20.prev = _context20.next) {
          case 0:
            query = query ? clone(query) : {};
            query._id = userId;
            _context20.next = 4;
            return this.users.update(query, {
              $addToSet: {
                'services.resume.loginTokens': hashedToken
              }
            });

          case 4:
          case 'end':
            return _context20.stop();
        }
      }
    }, _callee20, this);
  }));

  return function (_x37, _x38, _x39) {
    return _ref20.apply(this, arguments);
  };
}();

// Exported for tests.
Ap._insertLoginToken = function () {
  var _ref21 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee21(userId, stampedToken, query) {
    return _regenerator2.default.wrap(function _callee21$(_context21) {
      while (1) {
        switch (_context21.prev = _context21.next) {
          case 0:
            _context21.next = 2;
            return this._insertHashedLoginToken(userId, this._hashStampedToken(stampedToken), query);

          case 2:
          case 'end':
            return _context21.stop();
        }
      }
    }, _callee21, this);
  }));

  return function (_x40, _x41, _x42) {
    return _ref21.apply(this, arguments);
  };
}();

Ap._clearAllLoginTokens = function () {
  var _ref22 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee22(userId) {
    return _regenerator2.default.wrap(function _callee22$(_context22) {
      while (1) {
        switch (_context22.prev = _context22.next) {
          case 0:
            _context22.next = 2;
            return this.users.update(userId, {
              $set: {
                'services.resume.loginTokens': []
              }
            });

          case 2:
          case 'end':
            return _context22.stop();
        }
      }
    }, _callee22, this);
  }));

  return function (_x43) {
    return _ref22.apply(this, arguments);
  };
}();

function setupDefaultLoginHandlers(accounts) {
  accounts.registerLoginHandler('resume', function () {
    var _ref23 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee23(options) {
      return _regenerator2.default.wrap(function _callee23$(_context23) {
        while (1) {
          switch (_context23.prev = _context23.next) {
            case 0:
              return _context23.abrupt('return', defaultResumeLoginHandler.call(this, accounts, options));

            case 1:
            case 'end':
              return _context23.stop();
          }
        }
      }, _callee23, this);
    }));

    return function (_x44) {
      return _ref23.apply(this, arguments);
    };
  }());
}Ap._generateStampedLoginToken = function () {
  return {
    token: Random.secret(),
    when: new Date()
  };
};Ap._expireTokens = function () {
  var _ref26 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee26(oldestValidDate, userId) {
    var tokenLifetimeMs, userFilter;
    return _regenerator2.default.wrap(function _callee26$(_context26) {
      while (1) {
        switch (_context26.prev = _context26.next) {
          case 0:
            tokenLifetimeMs = this._getTokenLifetimeMs();

            // when calling from a test with extra arguments, you must specify both!

            if (!(oldestValidDate && !userId || !oldestValidDate && userId)) {
              _context26.next = 3;
              break;
            }

            throw new Error('Bad test. Must specify both oldestValidDate and userId.');

          case 3:

            oldestValidDate = oldestValidDate || new Date(new Date() - tokenLifetimeMs);
            userFilter = userId ? { _id: userId } : {};

            // Backwards compatible with older versions of meteor that stored login token
            // timestamps as numbers.

            _context26.next = 7;
            return this.users.update(extend(userFilter, {
              $or: [{ 'services.resume.loginTokens.when': { $lt: oldestValidDate } }, { 'services.resume.loginTokens.when': { $lt: +oldestValidDate } }]
            }), {
              $pull: {
                'services.resume.loginTokens': {
                  $or: [{ when: { $lt: oldestValidDate } }, { when: { $lt: +oldestValidDate } }]
                }
              }
            }, { multi: true });

          case 7:
          case 'end':
            return _context26.stop();
        }
      }
    }, _callee26, this);
  }));

  return function (_x51, _x52) {
    return _ref26.apply(this, arguments);
  };
}();

// Deletes expired password reset tokens from the database.
//
// Exported for tests. Also, the arguments are only used by
// tests. oldestValidDate is simulate expiring tokens without waiting
// for them to actually expire. userId is used by tests to only expire
// tokens for the test user.
Ap._expirePasswordResetTokens = function () {
  var _ref27 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee27(oldestValidDate, userId) {
    var tokenLifetimeMs, tokenFilter;
    return _regenerator2.default.wrap(function _callee27$(_context27) {
      while (1) {
        switch (_context27.prev = _context27.next) {
          case 0:
            tokenLifetimeMs = this._getPasswordResetTokenLifetimeMs();

            // when calling from a test with extra arguments, you must specify both!

            if (!(oldestValidDate && !userId || !oldestValidDate && userId)) {
              _context27.next = 3;
              break;
            }

            throw new Error('Bad test. Must specify both oldestValidDate and userId.');

          case 3:

            oldestValidDate = oldestValidDate || new Date(new Date() - tokenLifetimeMs);

            tokenFilter = {
              $or: [{ 'services.password.reset.reason': 'reset' }, { 'services.password.reset.reason': { $exists: false } }]
            };
            _context27.next = 7;
            return expirePasswordToken(this, oldestValidDate, tokenFilter, userId);

          case 7:
          case 'end':
            return _context27.stop();
        }
      }
    }, _callee27, this);
  }));

  return function (_x53, _x54) {
    return _ref27.apply(this, arguments);
  };
}();

// Deletes expired password enroll tokens from the database.
//
// Exported for tests. Also, the arguments are only used by
// tests. oldestValidDate is simulate expiring tokens without waiting
// for them to actually expire. userId is used by tests to only expire
// tokens for the test user.
Ap._expirePasswordEnrollTokens = function () {
  var _ref28 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee28(oldestValidDate, userId) {
    var tokenLifetimeMs, tokenFilter;
    return _regenerator2.default.wrap(function _callee28$(_context28) {
      while (1) {
        switch (_context28.prev = _context28.next) {
          case 0:
            tokenLifetimeMs = this._getPasswordEnrollTokenLifetimeMs();

            // when calling from a test with extra arguments, you must specify both!

            if (!(oldestValidDate && !userId || !oldestValidDate && userId)) {
              _context28.next = 3;
              break;
            }

            throw new Error('Bad test. Must specify both oldestValidDate and userId.');

          case 3:

            oldestValidDate = oldestValidDate || new Date(new Date() - tokenLifetimeMs);

            tokenFilter = {
              'services.password.reset.reason': 'enroll'
            };
            _context28.next = 7;
            return expirePasswordToken(this, oldestValidDate, tokenFilter, userId);

          case 7:
          case 'end':
            return _context28.stop();
        }
      }
    }, _callee28, this);
  }));

  return function (_x55, _x56) {
    return _ref28.apply(this, arguments);
  };
}();

// @override from accounts_common.js
Ap.config = function (options) {
  // Call the overridden implementation of the method.
  var superResult = AccountsCommon.prototype.config.apply(this, arguments);

  // If the user set loginExpirationInDays to null, then we need to clear the
  // timer that periodically expires tokens.
  if (has(this._options, 'loginExpirationInDays') && this._options.loginExpirationInDays === null && this.expireTokenInterval) {
    Timers.clearInterval(this.expireTokenInterval);
    this.expireTokenInterval = null;
  }

  return superResult;
};

function setExpireTokensInterval(accounts) {
  accounts.expireTokenInterval = Timers.setInterval((0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee29() {
    return _regenerator2.default.wrap(function _callee29$(_context29) {
      while (1) {
        switch (_context29.prev = _context29.next) {
          case 0:
            _context29.next = 2;
            return accounts._expireTokens();

          case 2:
            _context29.next = 4;
            return accounts._expirePasswordResetTokens();

          case 4:
            _context29.next = 6;
            return accounts._expirePasswordEnrollTokens();

          case 6:
          case 'end':
            return _context29.stop();
        }
      }
    }, _callee29, this);
  })), EXPIRE_TOKENS_INTERVAL_MS);
}

// XXX see comment on Accounts.createUser in passwords_server about adding a
// second "server options" argument.
function defaultCreateUserHook(options, user) {
  if (options.profile) {
    user.profile = options.profile;
  }
  return user;
}

// Called by accounts-password
Ap.insertUserDoc = function () {
  var _ref30 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee30(options, user) {
    var fullUser, userId;
    return _regenerator2.default.wrap(function _callee30$(_context30) {
      while (1) {
        switch (_context30.prev = _context30.next) {
          case 0:
            // - clone user document, to protect from modification
            // - add createdAt timestamp
            // - prepare an _id, so that you can modify other collections (eg
            // create a first task for every new user)
            //
            // XXX If the onCreateUser or validateNewUser hooks fail, we might
            // end up having modified some other collection
            // inappropriately. The solution is probably to have onCreateUser
            // accept two callbacks - one that gets called before inserting
            // the user document (in which you can modify its contents), and
            // one that gets called after (in which you should change other
            // collections)
            user = extend({
              createdAt: new Date(),
              _id: Random.id()
            }, user);

            if (this._onCreateUserHook) {
              fullUser = this._onCreateUserHook(options, user);

              // This is *not* part of the API. We need this because we can't isolate
              // the global server environment between tests, meaning we can't test
              // both having a create user hook set and not having one set.
              if (fullUser === 'TEST DEFAULT HOOK') {
                fullUser = defaultCreateUserHook(options, user);
              }
            } else {
              fullUser = defaultCreateUserHook(options, user);
            }

            each(this._validateNewUserHooks, function (hook) {
              if (!hook(fullUser)) {
                throw new AppError(403, 'User validation failed');
              }
            });

            _context30.prev = 3;
            _context30.next = 6;
            return this.users.insert(fullUser);

          case 6:
            userId = _context30.sent;
            _context30.next = 20;
            break;

          case 9:
            _context30.prev = 9;
            _context30.t0 = _context30['catch'](3);

            if (!(_context30.t0.name !== 'MongoError')) {
              _context30.next = 13;
              break;
            }

            throw _context30.t0;

          case 13:
            if (!(_context30.t0.code !== 11000)) {
              _context30.next = 15;
              break;
            }

            throw _context30.t0;

          case 15:
            if (!(_context30.t0.errmsg.indexOf('emails.address') !== -1)) {
              _context30.next = 17;
              break;
            }

            throw new AppError(403, 'Email already exists.');

          case 17:
            if (!(_context30.t0.errmsg.indexOf('username') !== -1)) {
              _context30.next = 19;
              break;
            }

            throw new AppError(403, 'Username already exists.');

          case 19:
            throw _context30.t0;

          case 20:
            return _context30.abrupt('return', userId);

          case 21:
          case 'end':
            return _context30.stop();
        }
      }
    }, _callee30, this, [[3, 9]]);
  }));

  return function (_x57, _x58) {
    return _ref30.apply(this, arguments);
  };
}();

// Helper function: returns false if email does not match company domain from
// the configuration.
Ap._testEmailDomain = function (email) {
  var domain = this._options.restrictCreationByEmailDomain;
  return !domain || isFunction(domain) && domain(email) || isString(domain) && new RegExp('@' + escapeRegExp(domain) + '$', 'i').test(email);
};

// Validate new user's email or Google/Facebook/GitHub account's email
function defaultValidateNewUserHook(user) {
  var self = this;
  var domain = self._options.restrictCreationByEmailDomain;
  if (!domain) {
    return true;
  }

  var emailIsGood = false;
  if (!isEmpty(user.emails)) {
    emailIsGood = every(user.emails, function (email) {
      return self._testEmailDomain(email.address);
    });
  } else if (!isEmpty(user.services)) {
    // Find any email of any service and check it
    emailIsGood = every(user.services, function (service) {
      return service.email && self._testEmailDomain(service.email);
    });
  }

  if (emailIsGood) {
    return true;
  }

  if (isString(domain)) {
    throw new AppError(403, '@' + domain + ' email required');
  } else {
    throw new AppError(403, "Email doesn't match the criteria.");
  }
}

//
/// MANAGING USER OBJECTS
//

// Updates or creates a user after we authenticate with a 3rd party.
//
// @param serviceName {String} Service name (eg, twitter).
// @param serviceData {Object} Data to store in the user's record
//        under services[serviceName]. Must include an "id" field
//        which is a unique identifier for the user in the service.
// @param options {Object, optional} Other options to pass to insertUserDoc
//        (eg, profile)
// @returns {Object} Object with token and id keys, like the result
//        of the "login" method.
//
Ap.updateOrCreateUserFromExternalService = function () {
  var _ref31 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee31(serviceName, serviceData, options) {
    var selector, serviceIdKey, user, opts, setAttrs;
    return _regenerator2.default.wrap(function _callee31$(_context31) {
      while (1) {
        switch (_context31.prev = _context31.next) {
          case 0:
            options = clone(options || {});

            if (!(serviceName === 'password' || serviceName === 'resume')) {
              _context31.next = 3;
              break;
            }

            throw new Error("Can't use updateOrCreateUserFromExternalService with internal service " + serviceName);

          case 3:
            if (has(serviceData, 'id')) {
              _context31.next = 5;
              break;
            }

            throw new Error('Service data for service ' + serviceName + ' must include id');

          case 5:

            // Look for a user with the appropriate service user id.
            selector = {};
            serviceIdKey = 'services.' + serviceName + '.id';

            // XXX Temporary special case for Twitter. (Issue #629)
            //   The serviceData.id will be a string representation of an integer.
            //   We want it to match either a stored string or int representation.
            //   This is to cater to earlier versions of Meteor storing twitter
            //   user IDs in number form, and recent versions storing them as strings.
            //   This can be removed once migration technology is in place, and twitter
            //   users stored with integer IDs have been migrated to string IDs.

            if (serviceName === 'twitter' && !isNaN(serviceData.id)) {
              selector['$or'] = [{}, {}];
              selector['$or'][0][serviceIdKey] = serviceData.id;
              selector['$or'][1][serviceIdKey] = parseInt(serviceData.id, 10);
            } else {
              selector[serviceIdKey] = serviceData.id;
            }

            _context31.next = 10;
            return this.users.findOne(selector);

          case 10:
            user = _context31.sent;


            // When creating a new user we pass through all options. When updating an
            // existing user, by default we only process/pass through the serviceData
            // (eg, so that we keep an unexpired access token and don't cache old email
            // addresses in serviceData.email). The onExternalLogin hook can be used when
            // creating or updating a user, to modify or pass through more options as
            // needed.
            opts = user ? {} : options;

            if (!user) {
              _context31.next = 21;
              break;
            }

            setAttrs = {};

            each(serviceData, function (value, key) {
              setAttrs['services.' + serviceName + '.' + key] = value;
            });

            // XXX Maybe we should re-use the selector above and notice if the update
            //     touches nothing?
            setAttrs = extend({}, setAttrs, opts);
            _context31.next = 18;
            return this.users.update(user._id, {
              $set: setAttrs
            });

          case 18:
            return _context31.abrupt('return', {
              type: serviceName,
              userId: user._id
            });

          case 21:
            // Create a new user with the service data.
            user = { services: {} };
            user.services[serviceName] = serviceData;
            _context31.t0 = serviceName;
            _context31.next = 26;
            return this.insertUserDoc(opts, user);

          case 26:
            _context31.t1 = _context31.sent;
            return _context31.abrupt('return', {
              type: _context31.t0,
              userId: _context31.t1
            });

          case 28:
          case 'end':
            return _context31.stop();
        }
      }
    }, _callee31, this);
  }));

  return function (_x59, _x60, _x61) {
    return _ref31.apply(this, arguments);
  };
}();

module.exports = {
  AccountsServer: AccountsServer
};