'use strict';

var _require = require('../../utils'),
    Timers = _require.Timers;

var _require2 = require('../../../server/next-plus'),
    addServerModule = _require2.addServerModule;

var _require3 = require('./accounts_server'),
    AccountsServer = _require3.AccountsServer;

addServerModule('defaultAccountsBaseModule', {
  setup: function setup() {
    this.getServiceConfig = getServiceConfig.bind(this);
  },
  startup: function startup() {
    var accounts = this.accounts = new AccountsServer(this);

    this.onClose(function () {
      if (accounts.expireTokenInterval) {
        Timers.clearInterval(accounts.expireTokenInterval);
      }
    });
  }
});

var getServiceConfig = function getServiceConfig(serviceName) {
  var services = this.getSetting('services') || {};
  return services[serviceName] || null;
};