'use strict';

// meteor/packages/accounts-oauth/oauth_common.js
// 26d4a1850705639bbbe20e8f16736b9a5af30cd4

var has = require('lodash/has');
var keys = require('lodash/keys');

var _require = require('../../utils'),
    isServer = _require.isServer;

module.exports = function (accounts) {
  accounts.oauth = {};

  var services = {};

  accounts.oauth.registerService = function (name) {
    if (has(services, name)) {
      throw new Error('Duplicate service: ' + name);
    }
    services[name] = true;

    if (isServer) {
      accounts.users._ensureIndex('services.' + name + '.id', {
        unique: 1,
        sparse: 1
      });
    }
  };

  accounts.oauth.unregisterService = function (name) {
    if (!has(services, name)) {
      throw new Error('Service not found: ' + name);
    }
    delete services[name];
  };

  accounts.oauth.serviceNames = function () {
    return keys(services);
  };
};