'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// meteor/packages/accounts-oauth/oauth_server.js
// 26d4a1850705639bbbe20e8f16736b9a5af30cd4

var includes = require('lodash/includes');

var _require = require('../../../server/next-plus'),
    addServerModule = _require.addServerModule;

var _require2 = require('../../utils'),
    check = _require2.check,
    Match = _require2.Match,
    AppError = _require2.AppError;

addServerModule('defaultAccountsOAuthModule', {
  startup: function startup() {
    var oauth = this.oauth;
    var accounts = this.accounts;

    require('./common')(accounts);

    accounts.registerLoginHandler(function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(options) {
        var result;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (options.oauth) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt('return', undefined);

              case 2:

                check(options.oauth, {
                  credentialToken: String,
                  credentialSecret: Match.OneOf(null, String)
                });

                _context.next = 5;
                return oauth.retrieveCredential(options.oauth.credentialToken, options.oauth.credentialSecret);

              case 5:
                result = _context.sent;

                if (result) {
                  _context.next = 8;
                  break;
                }

                return _context.abrupt('return', {
                  type: 'oauth',
                  error: new AppError(accounts.LoginCancelledError.numericError, 'No matching login attempt found')
                });

              case 8:
                if (!(result instanceof Error)) {
                  _context.next = 12;
                  break;
                }

                throw result;

              case 12:
                if (includes(accounts.oauth.serviceNames(), result.serviceName)) {
                  _context.next = 14;
                  break;
                }

                return _context.abrupt('return', {
                  type: 'oauth',
                  error: new AppError(accounts.LoginCancelledError.numericError, 'No registered oauth service found for: ' + result.serviceName)
                });

              case 14:
                return _context.abrupt('return', accounts.updateOrCreateUserFromExternalService(result.serviceName, result.serviceData, result.options));

              case 15:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
  }
});