'use strict';

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _jsxFileName = 'LoginForm.js';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');
var PropTypes = require('prop-types');

var _require = require('../../../app/next-plus'),
    compose = _require.compose,
    withAppSettings = _require.withAppSettings,
    withCurrentUser = _require.withCurrentUser;

var LoginForm = function (_React$PureComponent) {
  (0, _inherits3.default)(LoginForm, _React$PureComponent);

  function LoginForm() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, LoginForm);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = LoginForm.__proto__ || (0, _getPrototypeOf2.default)(LoginForm)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      changePasswordErrorMessage: '',
      forgotPasswordErrorMessage: '',
      registerErrorMessage: '',
      loginPasswordErrorMessage: '',
      loginGoogleErrorMessage: ''
    }, _this.getUserDisplayName = function (user) {
      if (user) {
        if (user.displayName) {
          return user.displayName;
        } else if (user.profile && user.profile.name) {
          return user.profile.name;
        } else if (user.username) {
          return user.username;
        } else if (user.emails && user.emails[0] && user.emails[0].address) {
          return user.emails[0].address;
        }
      }
      return '';
    }, _this.renderLoading = function () {
      return React.createElement(
        'div',
        { className: 'login-loading', __source: {
            fileName: _jsxFileName,
            lineNumber: 46
          }
        },
        'loading...'
      );
    }, _this.renderLoginName = function (_ref2) {
      var currentUser = _ref2.currentUser;

      return React.createElement(
        'div',
        { className: 'login-name', __source: {
            fileName: _jsxFileName,
            lineNumber: 51
          }
        },
        React.createElement(
          'b',
          {
            __source: {
              fileName: _jsxFileName,
              lineNumber: 52
            }
          },
          _this.getUserDisplayName(currentUser)
        )
      );
    }, _this.logout = function () {
      _this.context.app.logout();
    }, _this.renderLogoutButton = function () {
      return React.createElement(
        'div',
        { className: 'logout-button', __source: {
            fileName: _jsxFileName,
            lineNumber: 63
          }
        },
        React.createElement(
          'button',
          { onClick: _this.logout, __source: {
              fileName: _jsxFileName,
              lineNumber: 64
            }
          },
          'Logout'
        )
      );
    }, _this.changePassword = function () {
      var app = _this.context.app;
      var currentUser = _this.props.currentUser;
      var token = app.accounts._storedLoginToken();
      var oldPassword = document.getElementById('change-password-old-password').value;
      var newPassword = document.getElementById('change-password-new-password').value;
      var newPasswordAgain = document.getElementById('change-password-new-password-again').value;

      if (newPassword !== newPasswordAgain) {
        _this.setState({
          changePasswordErrorMessage: 'New password not match'
        });
        return;
      }

      app.accounts.changePassword(currentUser._id, token, oldPassword, newPassword, function (error) {
        if (error) {
          _this.setState({
            changePasswordErrorMessage: error.message
          });
        } else {
          try {
            _this.setState({
              changePasswordErrorMessage: ''
            });
            document.getElementById('change-password-old-password').value = '';
            document.getElementById('change-password-new-password').value = '';
            document.getElementById('change-password-new-password-again').value = '';
          } catch (__) {}
        }
      });
    }, _this.renderChangePassword = function (_ref3) {
      var services = _ref3.services,
          currentUser = _ref3.currentUser;

      if (!currentUser.services.password) return null;

      if (!(services.password && services.password.disabled)) {
        return React.createElement(
          'div',
          { className: 'change-password', __source: {
              fileName: _jsxFileName,
              lineNumber: 120
            }
          },
          React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 121
              }
            },
            React.createElement(
              'b',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 122
                }
              },
              'Change Password'
            )
          ),
          React.createElement(
            'div',
            { className: 'old-password-field', __source: {
                fileName: _jsxFileName,
                lineNumber: 124
              }
            },
            React.createElement(
              'label',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 125
                }
              },
              'Current Password'
            ),
            React.createElement('input', { id: 'change-password-old-password', type: 'password', __source: {
                fileName: _jsxFileName,
                lineNumber: 126
              }
            })
          ),
          React.createElement(
            'div',
            { className: 'new-password-field', __source: {
                fileName: _jsxFileName,
                lineNumber: 128
              }
            },
            React.createElement(
              'label',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 129
                }
              },
              'New Password'
            ),
            React.createElement('input', { id: 'change-password-new-password', type: 'password', __source: {
                fileName: _jsxFileName,
                lineNumber: 130
              }
            })
          ),
          React.createElement(
            'div',
            { className: 'new-password-again-field', __source: {
                fileName: _jsxFileName,
                lineNumber: 132
              }
            },
            React.createElement(
              'label',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 133
                }
              },
              'New Password (again)'
            ),
            React.createElement('input', { id: 'change-password-new-password-again', type: 'password', __source: {
                fileName: _jsxFileName,
                lineNumber: 134
              }
            })
          ),
          React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 136
              }
            },
            React.createElement(
              'i',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 137
                }
              },
              _this.state.changePasswordErrorMessage
            )
          ),
          React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 139
              }
            },
            React.createElement(
              'button',
              { onClick: _this.changePassword, __source: {
                  fileName: _jsxFileName,
                  lineNumber: 140
                }
              },
              'Change Password'
            )
          )
        );
      }
      return null;
    }, _this.renderLoggedIn = function (_ref4) {
      var services = _ref4.services,
          currentUser = _ref4.currentUser;

      return React.createElement(
        'div',
        { className: 'logged-in-list', __source: {
            fileName: _jsxFileName,
            lineNumber: 150
          }
        },
        _this.renderLoginName({ currentUser: currentUser }),
        _this.renderLogoutButton(),
        _this.renderChangePassword({ services: services, currentUser: currentUser })
      );
    }, _this.loginPassword = function () {
      var usernameOrEmail = document.getElementById('login-password-username-or-email').value;
      var password = document.getElementById('login-password-password').value;

      _this.context.app.loginWithPassword(usernameOrEmail, password, function (error) {
        if (error) {
          _this.setState({
            loginPasswordErrorMessage: error.message
          });
        } else {
          try {
            if (_this._ismounted) {
              _this.setState({
                registerErrorMessage: ''
              });
            }
            document.getElementById('login-password-username-or-email').value = '';
            document.getElementById('login-password-password').value = '';
          } catch (__) {}
        }
      });
    }, _this.renderPasswordLogin = function (_ref5) {
      var services = _ref5.services;

      if (!(services.password && services.password.disabled)) {
        return React.createElement(
          'div',
          { className: 'login-password', __source: {
              fileName: _jsxFileName,
              lineNumber: 186
            }
          },
          React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 187
              }
            },
            React.createElement(
              'b',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 188
                }
              },
              'Login'
            )
          ),
          React.createElement(
            'div',
            { className: 'username-or-email-field', __source: {
                fileName: _jsxFileName,
                lineNumber: 190
              }
            },
            React.createElement(
              'label',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 191
                }
              },
              'Username or Email'
            ),
            React.createElement('input', { id: 'login-password-username-or-email', __source: {
                fileName: _jsxFileName,
                lineNumber: 192
              }
            })
          ),
          React.createElement(
            'div',
            { className: 'password-field', __source: {
                fileName: _jsxFileName,
                lineNumber: 194
              }
            },
            React.createElement(
              'label',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 195
                }
              },
              'Password'
            ),
            React.createElement('input', { id: 'login-password-password', type: 'password', __source: {
                fileName: _jsxFileName,
                lineNumber: 196
              }
            })
          ),
          React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 198
              }
            },
            React.createElement(
              'i',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 199
                }
              },
              _this.state.loginPasswordErrorMessage
            )
          ),
          React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 201
              }
            },
            React.createElement(
              'button',
              { onClick: _this.loginPassword, __source: {
                  fileName: _jsxFileName,
                  lineNumber: 202
                }
              },
              'Sign In'
            )
          )
        );
      }
      return null;
    }, _this.loginGoogle = function () {
      _this.context.app.loginWithGoogle(function (error) {
        if (error) {
          _this.setState({
            loginGoogleErrorMessage: error.message
          });
        } else {
          try {
            if (_this._ismounted) {
              _this.setState({
                loginGoogleErrorMessage: ''
              });
            }
          } catch (__) {}
        }
      });
    }, _this.renderGoogleLogin = function (_ref6) {
      var services = _ref6.services;

      if (services && services.google) {
        return React.createElement(
          'div',
          { className: 'login-google', __source: {
              fileName: _jsxFileName,
              lineNumber: 231
            }
          },
          React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 232
              }
            },
            React.createElement(
              'b',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 233
                }
              },
              'Google Login'
            )
          ),
          React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 235
              }
            },
            React.createElement(
              'button',
              { onClick: _this.loginGoogle, __source: {
                  fileName: _jsxFileName,
                  lineNumber: 236
                }
              },
              'Google Login'
            )
          ),
          React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 238
              }
            },
            React.createElement(
              'i',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 239
                }
              },
              _this.state.loginGoogleErrorMessage
            )
          )
        );
      }
      return null;
    }, _this.renderSignIn = function (_ref7) {
      var services = _ref7.services;

      return React.createElement(
        'div',
        { className: 'sign-in', __source: {
            fileName: _jsxFileName,
            lineNumber: 249
          }
        },
        _this.renderPasswordLogin({ services: services }),
        _this.renderGoogleLogin({ services: services })
      );
    }, _this.register = function () {
      var app = _this.context.app;
      var usernameOrEmail = document.getElementById('register-username-or-email').value;
      var password = document.getElementById('register-password').value;
      var passwordAgain = document.getElementById('register-password-again').value;

      var username = '';
      var email = '';
      if (usernameOrEmail.indexOf('@') === -1) {
        username = usernameOrEmail;
      } else {
        email = usernameOrEmail;
      }

      if (password !== passwordAgain) {
        _this.setState({
          registerErrorMessage: 'password not match'
        });
        return;
      }

      app.accounts.createUser({ username: username, password: password, email: email }, function (error) {
        if (error) {
          _this.setState({
            registerErrorMessage: error.message
          });
        } else {
          try {
            if (_this._ismounted) {
              _this.setState({
                registerErrorMessage: ''
              });
            }
            document.getElementById('register-username-or-email').value = '';
            document.getElementById('register-password').value = '';
            document.getElementById('register-password-again').value = '';
          } catch (__) {}
        }
      });
    }, _this.renderRegister = function (_ref8) {
      var services = _ref8.services;

      if (!(services.password && services.password.disabled) && !(services.password && services.password.forbidClientAccountCreation)) {
        return React.createElement(
          'div',
          { className: 'register', __source: {
              fileName: _jsxFileName,
              lineNumber: 306
            }
          },
          React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 307
              }
            },
            React.createElement(
              'b',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 308
                }
              },
              'Register'
            )
          ),
          React.createElement(
            'div',
            { className: 'username-or-email-field', __source: {
                fileName: _jsxFileName,
                lineNumber: 310
              }
            },
            React.createElement(
              'label',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 311
                }
              },
              'Username or Email'
            ),
            React.createElement('input', { id: 'register-username-or-email', __source: {
                fileName: _jsxFileName,
                lineNumber: 312
              }
            })
          ),
          React.createElement(
            'div',
            { className: 'password-field', __source: {
                fileName: _jsxFileName,
                lineNumber: 314
              }
            },
            React.createElement(
              'label',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 315
                }
              },
              'Password'
            ),
            React.createElement('input', { id: 'register-password', type: 'password', __source: {
                fileName: _jsxFileName,
                lineNumber: 316
              }
            })
          ),
          React.createElement(
            'div',
            { className: 'password-again-field', __source: {
                fileName: _jsxFileName,
                lineNumber: 318
              }
            },
            React.createElement(
              'label',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 319
                }
              },
              'Password (again)'
            ),
            React.createElement('input', { id: 'register-password-again', type: 'password', __source: {
                fileName: _jsxFileName,
                lineNumber: 320
              }
            })
          ),
          React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 322
              }
            },
            React.createElement(
              'i',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 323
                }
              },
              _this.state.registerErrorMessage
            )
          ),
          React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 325
              }
            },
            React.createElement(
              'button',
              { onClick: _this.register, __source: {
                  fileName: _jsxFileName,
                  lineNumber: 326
                }
              },
              'Register'
            )
          )
        );
      }
      return null;
    }, _this.forgotPassword = function () {
      var app = _this.context.app;
      var email = document.getElementById('forgot-password-email').value;

      app.accounts.forgotPassword({ email: email }, function (error) {
        if (error) {
          _this.setState({
            forgotPasswordErrorMessage: error.message
          });
        } else {
          try {
            _this.setState({
              forgotPasswordErrorMessage: ''
            });
            document.getElementById('forgot-password-email').value = '';
          } catch (__) {}
        }
      });
    }, _this.renderForgotPassword = function (_ref9) {
      var services = _ref9.services;

      if (!(services.password && services.password.disabled)) {
        return React.createElement(
          'div',
          { className: 'forgot-password', __source: {
              fileName: _jsxFileName,
              lineNumber: 357
            }
          },
          React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 358
              }
            },
            React.createElement(
              'b',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 359
                }
              },
              'Forgot Password'
            )
          ),
          React.createElement(
            'div',
            { className: 'email-field', __source: {
                fileName: _jsxFileName,
                lineNumber: 361
              }
            },
            React.createElement(
              'label',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 362
                }
              },
              'Email'
            ),
            React.createElement('input', { id: 'forgot-password-email', __source: {
                fileName: _jsxFileName,
                lineNumber: 363
              }
            })
          ),
          React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 365
              }
            },
            React.createElement(
              'i',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 366
                }
              },
              _this.state.forgotPasswordErrorMessage
            )
          ),
          React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 368
              }
            },
            React.createElement(
              'button',
              { onClick: _this.forgotPassword, __source: {
                  fileName: _jsxFileName,
                  lineNumber: 369
                }
              },
              'Reset your password'
            )
          )
        );
      }
      return null;
    }, _this.renderLoggedOut = function (_ref10) {
      var services = _ref10.services;

      return React.createElement(
        'div',
        { className: 'logged-out-list', __source: {
            fileName: _jsxFileName,
            lineNumber: 379
          }
        },
        _this.renderSignIn({ services: services }),
        _this.renderRegister({ services: services })
      );
    }, _this.renderServices = function (_ref11) {
      var services = _ref11.services,
          currentUser = _ref11.currentUser,
          loadingCurrentUser = _ref11.loadingCurrentUser;

      return React.createElement(
        'div',
        { className: 'login-services', __source: {
            fileName: _jsxFileName,
            lineNumber: 389
          }
        },
        loadingCurrentUser && !currentUser ? _this.renderLoading() : currentUser ? _this.renderLoggedIn({ services: services, currentUser: currentUser }) : _this.renderLoggedOut({ services: services })
      );
    }, _this.renderNoServices = function () {
      return React.createElement(
        'div',
        { className: 'no-services', __source: {
            fileName: _jsxFileName,
            lineNumber: 400
          }
        },
        'No login services configured'
      );
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(LoginForm, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._ismounted = true;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this._ismounted = false;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          currentUser = _props.currentUser,
          loadingCurrentUser = _props.loadingCurrentUser;

      var services = this.context.app.getSetting('services') || {};

      return React.createElement(
        'div',
        { className: 'login-form', __source: {
            fileName: _jsxFileName,
            lineNumber: 408
          }
        },
        (0, _keys2.default)(services).length === 1 && services.password && services.password.disabled ? this.renderNoServices() : this.renderServices({ services: services, currentUser: currentUser, loadingCurrentUser: loadingCurrentUser })
      );
    }
  }]);
  return LoginForm;
}(React.PureComponent);

LoginForm.contextTypes = {
  app: PropTypes.object
};


module.exports = compose(withAppSettings, withCurrentUser)(LoginForm);