'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _jsxFileName = 'client.js';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');
var PropTypes = require('prop-types');

var _require = require('react-apollo'),
    Query = _require.Query;

var hoistNonReactStatics = require('hoist-non-react-statics');

var NextClient = require('../../app/next-plus');

var _require2 = require('../utils'),
    getComponentDisplayName = _require2.getComponentDisplayName,
    isClient = _require2.isClient;

require('./accounts-base/client');
require('./oauth/client');
require('./accounts-oauth/client');
require('./google-oauth/client');
require('./accounts-google/client');
require('./accounts-password/client');

NextClient.addAppModule('defaultAccountsModule', {
  setup: function setup() {
    require('./common')(this);

    this.getCurrentUserFromCache = getCurrentUserFromCache.bind(this);
  },
  afterStartup: function afterStartup() {
    if (isClient) {
      this.accounts._initialized = true;
    }
  }
});

var getCurrentUserFromCache = function getCurrentUserFromCache() {
  if (!this.client) {
    throw new Error('apollo client not defined');
  }
  try {
    var data = this.client.readQuery({
      query: this.getQuery('currentUser')
    });
    return data.currentUser || null;
  } catch (__) {}
  return null;
};

var QueryCurrentUser = function (_React$Component) {
  (0, _inherits3.default)(QueryCurrentUser, _React$Component);

  function QueryCurrentUser() {
    (0, _classCallCheck3.default)(this, QueryCurrentUser);
    return (0, _possibleConstructorReturn3.default)(this, (QueryCurrentUser.__proto__ || (0, _getPrototypeOf2.default)(QueryCurrentUser)).apply(this, arguments));
  }

  (0, _createClass3.default)(QueryCurrentUser, [{
    key: 'render',
    value: function render() {
      var children = this.props.children;
      var _context$app = this.context.app,
          ssr = _context$app.ssr,
          getQuery = _context$app.getQuery;


      return React.createElement(
        Query,
        {
          query: getQuery('currentUser'),
          fetchPolicy: ssr ? 'cache-first' : 'network-only',
          notifyOnNetworkStatusChange: true,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 53
          }
        },
        function (queryResult) {
          return children(queryResult);
        }
      );
    }
  }]);
  return QueryCurrentUser;
}(React.Component);

QueryCurrentUser.contextTypes = {
  app: PropTypes.object
};

NextClient.QueryCurrentUser = QueryCurrentUser;

NextClient.withCurrentUser = function (WrappedComponent) {
  var WithCurrentUser = function (_React$PureComponent) {
    (0, _inherits3.default)(WithCurrentUser, _React$PureComponent);

    function WithCurrentUser() {
      (0, _classCallCheck3.default)(this, WithCurrentUser);
      return (0, _possibleConstructorReturn3.default)(this, (WithCurrentUser.__proto__ || (0, _getPrototypeOf2.default)(WithCurrentUser)).apply(this, arguments));
    }

    (0, _createClass3.default)(WithCurrentUser, [{
      key: 'render',
      value: function render() {
        var _this3 = this;

        return React.createElement(
          QueryCurrentUser,
          {
            __source: {
              fileName: _jsxFileName,
              lineNumber: 71
            }
          },
          function (_ref) {
            var loading = _ref.loading,
                error = _ref.error,
                data = _ref.data;
            return React.createElement(WrappedComponent, (0, _extends3.default)({}, _this3.props, {
              loadingCurrentUser: loading,
              currentUser: data.currentUser || null,
              __source: {
                fileName: _jsxFileName,
                lineNumber: 73
              }
            }));
          }
        );
      }
    }]);
    return WithCurrentUser;
  }(React.PureComponent);

  WithCurrentUser.displayName = 'WithCurrentUser(' + getComponentDisplayName(WrappedComponent) + ')';


  hoistNonReactStatics(WithCurrentUser, WrappedComponent);
  return WithCurrentUser;
};