'use strict';

var _create = require('babel-runtime/core-js/object/create');

var _create2 = _interopRequireDefault(_create);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// meteor/packages/google-oauth/google_server.js
// 8987289234ddf5aaea239de32fcb919e247baf5a

var _require = require('../../../server/next-plus'),
    addServerModule = _require.addServerModule;

var _require2 = require('../../utils/http/server'),
    HTTP = _require2.HTTP;

var hasOwn = Object.prototype.hasOwnProperty;

var getIdentity = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(accessToken) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return HTTP.get('https://www.googleapis.com/oauth2/v1/userinfo', {
              params: { access_token: accessToken }
            });

          case 3:
            return _context.abrupt('return', _context.sent.data);

          case 6:
            _context.prev = 6;
            _context.t0 = _context['catch'](0);
            throw (0, _assign2.default)(new Error('Failed to fetch identity from Google. ' + _context.t0.message), { response: _context.t0.response });

          case 9:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[0, 6]]);
  }));

  return function getIdentity(_x) {
    return _ref.apply(this, arguments);
  };
}();

var getScopes = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(accessToken) {
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            _context2.next = 3;
            return HTTP.get('https://www.googleapis.com/oauth2/v1/tokeninfo', {
              params: { access_token: accessToken }
            });

          case 3:
            return _context2.abrupt('return', _context2.sent.data.scope.split(' '));

          case 6:
            _context2.prev = 6;
            _context2.t0 = _context2['catch'](0);
            throw (0, _assign2.default)(new Error('Failed to fetch tokeninfo from Google. ' + _context2.t0.message), { response: _context2.t0.response });

          case 9:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this, [[0, 6]]);
  }));

  return function getScopes(_x2) {
    return _ref2.apply(this, arguments);
  };
}();

var whitelistedFields = ['id', 'email', 'verified_email', 'name', 'given_name', 'family_name', 'picture', 'locale', 'timezone', 'gender'];

addServerModule('defaultGoogleOAuthModule', {
  startup: function startup() {
    var getServiceDataFromTokens = function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(tokens) {
        var accessToken, idToken, scopes, identity, serviceData, fields;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                accessToken = tokens.accessToken;
                idToken = tokens.idToken;
                _context3.next = 4;
                return getScopes(accessToken);

              case 4:
                scopes = _context3.sent;
                _context3.next = 7;
                return getIdentity(accessToken);

              case 7:
                identity = _context3.sent;
                serviceData = {
                  accessToken: accessToken,
                  idToken: idToken,
                  scope: scopes
                };


                if (hasOwn.call(tokens, 'expiresIn')) {
                  serviceData.expiresAt = Date.now() + 1000 * parseInt(tokens.expiresIn, 10);
                }

                fields = (0, _create2.default)(null);

                whitelistedFields.forEach(function (name) {
                  if (hasOwn.call(identity, name)) {
                    fields[name] = identity[name];
                  }
                });

                (0, _assign2.default)(serviceData, fields);

                if (tokens.refreshToken) {
                  serviceData.refreshToken = tokens.refreshToken;
                }

                return _context3.abrupt('return', {
                  serviceData: serviceData,
                  options: {
                    profile: {
                      name: identity.name
                    }
                  }
                });

              case 15:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      return function getServiceDataFromTokens(_x3) {
        return _ref3.apply(this, arguments);
      };
    }();

    var getServiceData = function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(query) {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.t0 = getServiceDataFromTokens;
                _context4.next = 3;
                return getTokens(query);

              case 3:
                _context4.t1 = _context4.sent;
                return _context4.abrupt('return', (0, _context4.t0)(_context4.t1));

              case 5:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      return function getServiceData(_x4) {
        return _ref4.apply(this, arguments);
      };
    }();

    if (!this.getServiceConfig('google')) {
      this.debug('Service config \'google\' not found. google-oauth module not loaded.');
      return;
    }

    if (process.env.GOOGLE_CLIENT_ID) {
      var publicSettings = this.settings.public;
      publicSettings.services = publicSettings.services || {};
      publicSettings.services.google = publicSettings.services.google || {};
      publicSettings.services.google.clientId = process.env.GOOGLE_CLIENT_ID;
    }

    try {
      var googlePublicSecret = this.settings.public.services.google.secret;
      if (googlePublicSecret && !process.env.GOOGLE_CLIENT_SECRET) {
        process.env.GOOGLE_CLIENT_SECRET = googlePublicSecret;
      }
      delete this.settings.public.services.google.secret;
    } catch (__) {}

    var server = this;
    var oauth = server.oauth;

    oauth.registerService('google', 2, null, getServiceData);

    var getTokens = function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(query) {
        var oauth, services, config, response;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                oauth = server.oauth;
                services = server.getSetting('services') || {};
                config = services['google'];

                if (process.env.GOOGLE_CLIENT_SECRET) {
                  config = config || {};
                  config.secret = process.env.GOOGLE_CLIENT_SECRET;
                }

                if (config) {
                  _context5.next = 6;
                  break;
                }

                throw new Error('Service google not configured');

              case 6:
                _context5.prev = 6;
                _context5.next = 9;
                return HTTP.post('https://accounts.google.com/o/oauth2/token', {
                  params: {
                    code: query.code,
                    client_id: config.clientId,
                    client_secret: oauth.openSecret(config.secret),
                    redirect_uri: oauth._redirectUri('google', config),
                    grant_type: 'authorization_code'
                  }
                });

              case 9:
                response = _context5.sent;
                _context5.next = 15;
                break;

              case 12:
                _context5.prev = 12;
                _context5.t0 = _context5['catch'](6);
                throw (0, _assign2.default)(new Error('Failed to complete OAuth handshake with Google. ' + _context5.t0.message), { response: _context5.t0.response });

              case 15:
                if (!response.data.error) {
                  _context5.next = 19;
                  break;
                }

                throw new Error('Failed to complete OAuth handshake with Google. ' + response.data.error);

              case 19:
                return _context5.abrupt('return', {
                  accessToken: response.data.access_token,
                  refreshToken: response.data.refresh_token,
                  expiresIn: response.data.expires_in,
                  idToken: response.data.id_token
                });

              case 20:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this, [[6, 12]]);
      }));

      return function getTokens(_x5) {
        return _ref5.apply(this, arguments);
      };
    }();
  }
});