'use strict';

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// meteor/packages/oauth/oauth_server.js
// 6418026e15950e2457a94762ab2f892e5352d1fc

var each = require('lodash/each');
var keys = require('lodash/keys');
var clone = require('lodash/clone');
var isEmpty = require('lodash/isEmpty');

var _require = require('../../utils/url/server'),
    URL = _require.URL;

var _require2 = require('./oauth_common'),
    OAuthCommon = _require2.OAuthCommon;

var _endOfPopupResponseTemplate = '\n<html>\n<body>\n  <p id="completedText" style="display:none;">\n    Login completed. <a href="#" id="loginCompleted">\n      Click here</a> to close this window.\n  </p>\n\n  <div id="config" style="display:none;">##CONFIG##</div>\n  <script type="text/javascript">\n    (function () {\n      var config = JSON.parse(document.getElementById(\'config\').innerHTML)\n\n      if (config.setCredentialToken) {\n        var credentialToken = config.credentialToken\n        var credentialSecret = config.credentialSecret\n\n        if (window.opener && window.opener.app && window.opener.app.oauth) {\n          window.opener.app.oauth._handleCredentialSecret(credentialToken, credentialSecret)\n        } else {\n          try {\n            window.localStorage[config.storagePrefix + credentialToken] = credentialSecret\n          } catch (err) {\n            // We can\'t do much else, but at least close the popup instead\n            // of having it hang around on a blank page.\n          }\n        }\n      }\n\n      document.getElementById(\'completedText\').style.display = \'block\'\n      document.getElementById(\'loginCompleted\').onclick = function () { window.close() }\n      window.close()\n    })()\n  </script>\n</body>\n</html>\n';

var _endOfRedirectResponseTemplate = '\n<html>\n<body>\n  <div id="config" style="display:none;">##CONFIG##</div>\n  <script type="text/javascript">\n    (function () {\n      var config = JSON.parse(document.getElementById(\'config\').innerHTML)\n\n      if (config.setCredentialToken) {\n        window.sessionStorage[config.storagePrefix + config.credentialToken] = config.credentialSecret\n      }\n\n      window.location =\n        config.redirectUrl\n          ? config.redirectUrl.replace(/&amp;/g, "&")\n          : config.redirectUrl\n    })()\n  </script>\n</body>\n</html>\n';

var OAuthServer = function (_OAuthCommon) {
  (0, _inherits3.default)(OAuthServer, _OAuthCommon);

  function OAuthServer(server) {
    (0, _classCallCheck3.default)(this, OAuthServer);

    var _this = (0, _possibleConstructorReturn3.default)(this, (OAuthServer.__proto__ || (0, _getPrototypeOf2.default)(OAuthServer)).call(this, server));

    _this.server = server;
    _this.registeredServices = {};
    _this._requestHandlers = {};
    _this._endOfPopupResponseTemplate = _endOfPopupResponseTemplate;
    _this._endOfRedirectResponseTemplate = _endOfRedirectResponseTemplate;

    _this.initPendingCredentials();
    return _this;
  }

  (0, _createClass3.default)(OAuthServer, [{
    key: '_redirectUri',
    value: function _redirectUri(serviceName, config, params, absoluteUrlOptions) {
      var query = config.loginStyle ? null : 'close';

      if (params) {
        params = clone(params);
        if (isEmpty(params)) {
          params = undefined;
        }
      }

      return URL._constructUrl(this.instance.absoluteUrl('_oauth/' + serviceName, absoluteUrlOptions), query, params);
    }
  }]);
  return OAuthServer;
}(OAuthCommon);

// Register a handler for an OAuth service. The handler will be called
// when we get an incoming http request on /_oauth/{serviceName}. This
// handler should use that information to fetch data about the user
// logging in.
//
// @param name {String} e.g. "google", "facebook"
// @param version {Number} OAuth version (1 or 2)
// @param urls   For OAuth1 only, specify the service's urls
// @param handleOauthRequest {Function(oauthBinding|query)}
//   - (For OAuth1 only) oauthBinding {OAuth1Binding} bound to the appropriate provider
//   - (For OAuth2 only) query {Object} parameters passed in query string
//   - return value is:
//     - {serviceData:, (optional options:)} where serviceData should end
//       up in the user's services[name] field
//     - `null` if the user declined to give permissions
//


OAuthServer.prototype.registerService = function (name, version, urls, handleOauthRequest) {
  if (this.registeredServices[name]) {
    throw new Error('Already registered the ' + name + ' OAuth service');
  }

  this.registeredServices[name] = {
    serviceName: name,
    version: version,
    urls: urls,
    handleOauthRequest: handleOauthRequest
  };
};

OAuthServer.prototype.retrieveCredential = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(credentialToken, credentialSecret) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt('return', this._retrievePendingCredential(credentialToken, credentialSecret));

          case 1:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

// The state parameter is normally generated on the client using
// `btoa`, but for tests we need a version that runs on the server.
//
OAuthServer.prototype._generateState = function (loginStyle, credentialToken, redirectUrl) {
  return Buffer.from((0, _stringify2.default)({
    loginStyle: loginStyle,
    credentialToken: credentialToken,
    redirectUrl: redirectUrl
  })).toString('base64');
};

OAuthServer.prototype._stateFromQuery = function (query) {
  var string;
  try {
    string = Buffer.from(query.state, 'base64').toString('binary');
  } catch (e) {
    console.warn('Unable to base64 decode state from OAuth query: ' + query.state);
    throw e;
  }

  try {
    return JSON.parse(string);
  } catch (e) {
    console.warn('Unable to parse state from OAuth query: ' + string);
    throw e;
  }
};

OAuthServer.prototype._loginStyleFromQuery = function (query) {
  var style;
  // For backwards-compatibility for older clients, catch any errors
  // that result from parsing the state parameter. If we can't parse it,
  // set login style to popup by default.
  try {
    style = this._stateFromQuery(query).loginStyle;
  } catch (err) {
    style = 'popup';
  }
  if (style !== 'popup' && style !== 'redirect') {
    throw new Error('Unrecognized login style: ' + style);
  }
  return style;
};

OAuthServer.prototype._credentialTokenFromQuery = function (query) {
  var state;
  // For backwards-compatibility for older clients, catch any errors
  // that result from parsing the state parameter. If we can't parse it,
  // assume that the state parameter's value is the credential token, as
  // it used to be for older clients.
  try {
    state = this._stateFromQuery(query);
  } catch (err) {
    return query.state;
  }
  return state.credentialToken;
};

// Checks if the `redirectUrl` matches the app host.
// We export this function so that developers can override this
// behavior to allow apps from external domains to login using the
// redirect OAuth flow.
OAuthServer.prototype._checkRedirectUrlOrigin = function (redirectUrl) {
  var appHost = this.server.absoluteUrl();
  var appHostReplacedLocalhost = this.server.absoluteUrl(undefined, {
    replaceLocalhost: true
  });
  return redirectUrl.substr(0, appHost.length) !== appHost && redirectUrl.substr(0, appHostReplacedLocalhost.length) !== appHostReplacedLocalhost;
};

OAuthServer.prototype.middleware = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(req, res, next) {
    var serviceName, service, handler;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            serviceName = oauthServiceName(req);

            if (serviceName) {
              _context2.next = 5;
              break;
            }

            // not an oauth request. pass to next middleware.
            next();
            return _context2.abrupt('return');

          case 5:
            service = this.registeredServices[serviceName];

            // Skip everything if there's no service set by the oauth middleware

            if (service) {
              _context2.next = 8;
              break;
            }

            throw new Error('Unexpected OAuth service ' + serviceName);

          case 8:

            // Make sure we're configured
            this.ensureConfigured(serviceName);

            handler = this._requestHandlers[service.version];

            if (handler) {
              _context2.next = 12;
              break;
            }

            throw new Error('Unexpected OAuth version ' + service.version);

          case 12:
            _context2.next = 14;
            return handler(service, req.query, res);

          case 14:
            _context2.next = 28;
            break;

          case 16:
            _context2.prev = 16;
            _context2.t0 = _context2['catch'](0);

            if (!(req.query.state && _context2.t0 instanceof Error)) {
              _context2.next = 27;
              break;
            }

            _context2.prev = 19;
            _context2.next = 22;
            return this._storePendingCredential(this._credentialTokenFromQuery(req.query), _context2.t0);

          case 22:
            _context2.next = 27;
            break;

          case 24:
            _context2.prev = 24;
            _context2.t1 = _context2['catch'](19);

            // Ignore the error and just give up. If we failed to store the
            // error, then the login will just fail with a generic error.
            console.warn('Error in OAuth Server while storing pending login result.\n' + _context2.t1.stack || _context2.t1.message);

          case 27:

            // close the popup. because nobody likes them just hanging
            // there.  when someone sees this multiple times they might
            // think to check server logs (we hope?)
            // Catch errors because any exception here will crash the runner.
            try {
              this._endOfLoginResponse(res, {
                query: req.query,
                loginStyle: this._loginStyleFromQuery(req.query),
                error: _context2.t0
              });
            } catch (err) {
              console.warn('Error generating end of login response\n' + (err && (err.stack || err.message)));
            }

          case 28:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this, [[0, 16], [19, 24]]);
  }));

  return function (_x3, _x4, _x5) {
    return _ref2.apply(this, arguments);
  };
}();

// Handle /_oauth/* paths and extract the service name.
//
// @returns {String|null} e.g. "facebook", or null if this isn't an
// oauth request
var oauthServiceName = function oauthServiceName(req) {
  // req.url will be "/_oauth/<service name>" with an optional "?close".
  var i = req.url.indexOf('?');
  var barePath;
  if (i === -1) {
    barePath = req.url;
  } else {
    barePath = req.url.substring(0, i);
  }
  var splitPath = barePath.split('/');

  // Any non-oauth request will continue down the default
  // middlewares.
  if (splitPath[1] !== '_oauth') {
    return null;
  }

  // Find service based on url
  var serviceName = splitPath[2];
  return serviceName;
};

// Make sure we're configured
OAuthServer.prototype.ensureConfigured = function (serviceName) {
  var services = this.server.getSetting('services') || {};
  if (!services[serviceName]) {
    throw new Error('Service ' + serviceName + ' not configured');
  }
};

var isSafe = function isSafe(value) {
  // This matches strings generated by `Random.secret` and
  // `Random.id`.
  return typeof value === 'string' && /^[a-zA-Z0-9\-_]+$/.test(value);
};

// Internal: used by the oauth1 and oauth2 packages
OAuthServer.prototype._renderOauthResults = function (res, query, credentialSecret) {
  // For tests, we support the `only_credential_secret_for_test`
  // parameter, which just returns the credential secret without any
  // surrounding HTML. (The test needs to be able to easily grab the
  // secret and use it to log in.)
  //
  // XXX only_credential_secret_for_test could be useful for other
  // things beside tests, like command-line clients. We should give it a
  // real name and serve the credential secret in JSON.

  var details = {
    query: query,
    loginStyle: this._loginStyleFromQuery(query)
  };
  if (query.error) {
    details.error = query.error;
  } else {
    var token = this._credentialTokenFromQuery(query);
    var secret = credentialSecret;
    if (token && secret && isSafe(token) && isSafe(secret)) {
      details.credentials = { token: token, secret: secret };
    } else {
      details.error = 'invalid_credential_token_or_secret';
    }
  }

  this._endOfLoginResponse(res, details);
};

// Renders the end of login response template into some HTML and JavaScript
// that closes the popup or redirects at the end of the OAuth flow.
//
// options are:
//   - loginStyle ("popup" or "redirect")
//   - setCredentialToken (boolean)
//   - credentialToken
//   - credentialSecret
//   - redirectUrl
//   - isCordova (boolean)
//
OAuthServer.prototype.renderEndOfLoginResponse = function (options) {
  // It would be nice to use Blaze here, but it's a little tricky
  // because our mustaches would be inside a <script> tag, and Blaze
  // would treat the <script> tag contents as text (e.g. encode '&' as
  // '&amp;'). So we just do a simple replace.

  var escape = function escape(s) {
    if (s) {
      return s.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;').replace(/'/g, '&#x27;').replace(/\//g, '&#x2F;');
    } else {
      return s;
    }
  };

  // Escape everything just to be safe (we've already checked that some
  // of this data -- the token and secret -- are safe).
  var config = {
    setCredentialToken: !!options.setCredentialToken,
    credentialToken: escape(options.credentialToken),
    credentialSecret: escape(options.credentialSecret),
    storagePrefix: escape(this._storageTokenPrefix),
    redirectUrl: escape(options.redirectUrl)
  };

  var template;
  if (options.loginStyle === 'popup') {
    template = this._endOfPopupResponseTemplate;
  } else if (options.loginStyle === 'redirect') {
    template = this._endOfRedirectResponseTemplate;
  } else {
    throw new Error('invalid loginStyle: ' + options.loginStyle);
  }

  var result = template.replace(/##CONFIG##/, (0, _stringify2.default)(config));

  return '<!DOCTYPE html>\n' + result;
};

// Writes an HTTP response to the popup window at the end of an OAuth
// login flow. At this point, if the user has successfully authenticated
// to the OAuth server and authorized this app, we communicate the
// credentialToken and credentialSecret to the main window. The main
// window must provide both these values to the DDP `login` method to
// authenticate its DDP connection. After communicating these vaues to
// the main window, we close the popup.
//
// We export this function so that developers can override this
// behavior, which is particularly useful in, for example, some mobile
// environments where popups and/or `window.opener` don't work. For
// example, an app could override `OAuth._endOfPopupResponse` to put the
// credential token and credential secret in the popup URL for the main
// window to read them there instead of using `window.opener`. If you
// override this function, you take responsibility for writing to the
// request and calling `res.end()` to complete the request.
//
// Arguments:
//   - res: the HTTP response object
//   - details:
//      - query: the query string on the HTTP request
//      - credentials: { token: *, secret: * }. If present, this field
//        indicates that the login was successful. Return these values
//        to the client, who can use them to log in over DDP. If
//        present, the values have been checked against a limited
//        character set and are safe to include in HTML.
//      - error: if present, a string or Error indicating an error that
//        occurred during the login. This can come from the client and
//        so shouldn't be trusted for security decisions or included in
//        the response without sanitizing it first. Only one of `error`
//        or `credentials` should be set.
OAuthServer.prototype._endOfLoginResponse = function (res, details) {
  res.writeHead(200, { 'Content-Type': 'text/html' });

  var redirectUrl;
  if (details.loginStyle === 'redirect') {
    redirectUrl = this._stateFromQuery(details.query).redirectUrl;
    var appHost = this.server.absoluteUrl();
    if (this._checkRedirectUrlOrigin(redirectUrl)) {
      details.error = 'redirectUrl (' + redirectUrl + ') is not on the same host as the app (' + appHost + ')';
      redirectUrl = appHost;
    }
  }

  if (details.error) {
    console.warn('Error in OAuth Server: ' + (details.error instanceof Error ? details.error.message : details.error));
    res.end(this.renderEndOfLoginResponse({
      loginStyle: details.loginStyle,
      setCredentialToken: false,
      redirectUrl: redirectUrl
    }), 'utf-8');
    return;
  }

  // If we have a credentialSecret, report it back to the parent
  // window, with the corresponding credentialToken. The parent window
  // uses the credentialToken and credentialSecret to log in over DDP.
  res.end(this.renderEndOfLoginResponse({
    loginStyle: details.loginStyle,
    setCredentialToken: true,
    credentialToken: details.credentials.token,
    credentialSecret: details.credentials.secret,
    redirectUrl: redirectUrl
  }), 'utf-8');
};

// Encrypt sensitive service data such as access tokens if the
// "oauth-encryption" package is loaded and the oauth secret key has
// been specified.  Returns the unencrypted plaintext otherwise.
//
// The user id is not specified because the user isn't known yet at
// this point in the oauth authentication process.  After the oauth
// authentication process completes the encrypted service data fields
// will be re-encrypted with the user id included before inserting the
// service data into the user document.
//
OAuthServer.prototype.sealSecret = function (plaintext) {
  return plaintext;
};

// Unencrypt a service data field, if the "oauth-encryption"
// package is loaded and the field is encrypted.
//
// Throws an error if the "oauth-encryption" package is loaded and the
// field is encrypted, but the oauth secret key hasn't been specified.
//
OAuthServer.prototype.openSecret = function (maybeSecret, userId) {
  return maybeSecret;
};

// Unencrypt fields in the service data object.
//
OAuthServer.prototype.openSecrets = function (serviceData, userId) {
  var result = {};
  each(keys(serviceData), function (key) {
    result[key] = this.openSecret(serviceData[key], userId);
  });
  return result;
};

module.exports = {
  OAuthServer: OAuthServer
};