'use strict';

var _require = require('../../utils'),
    Timers = _require.Timers;

var _require2 = require('../../../server/next-plus'),
    addServerModule = _require2.addServerModule;

var _require3 = require('./oauth_server'),
    OAuthServer = _require3.OAuthServer;

require('./pending_credentials');

addServerModule('defaultOAuthModule', {
  startup: function startup() {
    var server = this;
    server.oauth = new OAuthServer(server);
    this.onClose(function () {
      if (server.oauth._cleanStaleResultsInterval) {
        Timers.clearInterval(server.oauth._cleanStaleResultsInterval);
      }
    });
  },
  afterStartup: function afterStartup() {
    var server = this;
    server.appHandlers.use(function oauthMiddleware(req, res, next) {
      server.oauth.middleware(req, res, next);
    });
  }
});