'use strict';

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('../../server/next-plus'),
    addServerModule = _require.addServerModule;

var _require2 = require('../utils/mongo'),
    Mongo = _require2.Mongo,
    MongoInternals = _require2.MongoInternals;

addServerModule('defaultCollectionsModule', {
  setup: function setup() {
    this.collections = {};

    this.createCollection = createCollection.bind(this);
    this.registerCollection = registerCollection.bind(this);
    this.getCollection = getCollection.bind(this);
    this.getCollections = getCollections.bind(this);
  },
  afterStartup: function afterStartup() {
    var _this = this;

    this.onClose((0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(MongoInternals && MongoInternals.defaultRemoteCollectionDriver)) {
                _context.next = 3;
                break;
              }

              _context.next = 3;
              return MongoInternals.defaultRemoteCollectionDriver().mongo.close();

            case 3:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this);
    })));
  }
});

var createCollection = function createCollection(collectionName) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  if ((typeof collectionName === 'undefined' ? 'undefined' : (0, _typeof3.default)(collectionName)) === 'object') {
    options = collectionName;
    collectionName = undefined;
  }

  if (!options.collectionName) {
    options.collectionName = collectionName;
  }

  if (!options.dbCollectionName) {
    options.dbCollectionName = collectionName.toLowerCase();
  }

  var collection = new Mongo.Collection(options.dbCollectionName);
  collection.options = options;

  return this.registerCollection(options.collectionName, collection);
};

var registerCollection = function registerCollection(name, collection) {
  collection.name = name;
  this.collections[name] = collection;
  return collection;
};

var getCollection = function getCollection(name) {
  return this.collections[name];
};

var getCollections = function getCollections() {
  return this.collections;
};