'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _jsxFileName = 'client.js';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');
var PropTypes = require('prop-types');
var gql = require('graphql-tag');

var _require = require('react-apollo'),
    Query = _require.Query,
    Mutation = _require.Mutation;

var hoistNonReactStatics = require('hoist-non-react-statics');
var uniq = require('lodash/uniq');
var extend = require('lodash/extend');
var omit = require('lodash/omit');
var some = require('lodash/some');
var keys = require('lodash/keys');

var _require2 = require('../utils'),
    getComponentDisplayName = _require2.getComponentDisplayName;

var NextClient = require('../../app/next-plus');

var _require3 = require('./common'),
    registerFragment = _require3.registerFragment,
    extendFragment = _require3.extendFragment,
    getFragment = _require3.getFragment,
    registerQuery = _require3.registerQuery,
    getQuery = _require3.getQuery,
    registerMutation = _require3.registerMutation,
    getMutation = _require3.getMutation;

NextClient.addAppModule('defaultGraphqlSchemaModule', {
  setup: function setup() {
    this.queries = {};
    this.mutations = {};
    this.fragments = {};

    this.registerFragment = registerFragment.bind(this);
    this.extendFragment = extendFragment.bind(this);
    this.getFragment = getFragment.bind(this);
    this.registerQuery = registerQuery.bind(this);
    this.getQuery = getQuery.bind(this);
    this.registerMutation = registerMutation.bind(this);
    this.getMutation = getMutation.bind(this);
  }
});

NextClient.withQuery = function () {
  var queryProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return function (WrappedComponent) {
    var WithQuery = function (_React$PureComponent) {
      (0, _inherits3.default)(WithQuery, _React$PureComponent);

      function WithQuery() {
        (0, _classCallCheck3.default)(this, WithQuery);
        return (0, _possibleConstructorReturn3.default)(this, (WithQuery.__proto__ || (0, _getPrototypeOf2.default)(WithQuery)).apply(this, arguments));
      }

      (0, _createClass3.default)(WithQuery, [{
        key: 'render',
        value: function render() {
          var _this2 = this;

          // query props
          if (typeof queryProps === 'function') {
            queryProps = queryProps(this.props, this.context);
          }

          var _queryProps = queryProps,
              query = _queryProps.query,
              mapResultToProps = _queryProps.mapResultToProps,
              other = (0, _objectWithoutProperties3.default)(_queryProps, ['query', 'mapResultToProps']);

          // get document

          if (typeof query === 'string') {
            if (/^[_A-Za-z][_0-9A-Za-z]*$/.test(query)) {
              query = this.context.app.getQuery(query);
            } else {
              query = gql.apply(undefined, [query].concat((0, _toConsumableArray3.default)(uniq((query.match(/\.{3}([_A-Za-z][_0-9A-Za-z]*)/g) || []).map(function (f) {
                return f.replace('...', '');
              })).map(function (name) {
                return _this2.context.app.getFragment(name);
              }))));
            }
          } else if (typeof query === 'function') {
            query = query();
          }

          return React.createElement(
            Query,
            (0, _extends3.default)({ query: query }, other, {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 76
              }
            }),
            function (queryResult) {
              var resultProps = void 0;
              if (mapResultToProps) {
                resultProps = mapResultToProps(queryResult);
              } else {
                var document = query;
                var operationName = '';
                if (document && document.definitions[0]) {
                  operationName = document.definitions[0].name.value;
                }
                var dataPropName = operationName || 'data';

                _this2._data = _this2._data || {};
                if (some(['error', 'loading', 'networkStatus'], function (name) {
                  return queryResult[name] !== _this2._data[name];
                }) || some(keys(queryResult.data), function (name) {
                  return queryResult.data[name] !== _this2._data[name];
                })) {
                  _this2._data = {};
                }

                extend(_this2._data, omit(queryResult, 'data'), queryResult.data);

                resultProps = (0, _defineProperty3.default)({}, dataPropName, _this2._data);
              }

              return React.createElement(WrappedComponent, (0, _extends3.default)({}, _this2.props, resultProps, {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 111
                }
              }));
            }
          );
        }
      }]);
      return WithQuery;
    }(React.PureComponent);

    WithQuery.displayName = 'WithQuery(' + getComponentDisplayName(WrappedComponent) + ')';
    WithQuery.contextTypes = {
      app: PropTypes.object
    };


    hoistNonReactStatics(WithQuery, WrappedComponent);
    return WithQuery;
  };
};

NextClient.withMutation = function () {
  var mutationProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return function (WrappedComponent) {
    var WithMutation = function (_React$PureComponent2) {
      (0, _inherits3.default)(WithMutation, _React$PureComponent2);

      function WithMutation() {
        var _ref;

        var _temp, _this3, _ret;

        (0, _classCallCheck3.default)(this, WithMutation);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this3 = (0, _possibleConstructorReturn3.default)(this, (_ref = WithMutation.__proto__ || (0, _getPrototypeOf2.default)(WithMutation)).call.apply(_ref, [this].concat(args))), _this3), _initialiseProps.call(_this3), _temp), (0, _possibleConstructorReturn3.default)(_this3, _ret);
      }

      (0, _createClass3.default)(WithMutation, [{
        key: 'render',
        value: function render() {
          var _this4 = this;

          // mutation props
          if (typeof mutationProps === 'function') {
            mutationProps = mutationProps(this.props, this.context);
          }

          var _mutationProps = mutationProps,
              mutation = _mutationProps.mutation,
              mapResultToProps = _mutationProps.mapResultToProps,
              other = (0, _objectWithoutProperties3.default)(_mutationProps, ['mutation', 'mapResultToProps']);

          // get document

          if (typeof mutation === 'string') {
            if (/^[_A-Za-z][_0-9A-Za-z]*$/.test(mutation)) {
              mutation = this.context.app.getMutation(mutation);
            } else {
              mutation = gql.apply(undefined, [mutation].concat((0, _toConsumableArray3.default)(uniq((mutation.match(/\.{3}([_A-Za-z][_0-9A-Za-z]*)/g) || []).map(function (f) {
                return f.replace('...', '');
              })).map(function (name) {
                return _this4.context.app.getFragment(name);
              }))));
            }
          } else if (typeof mutation === 'function') {
            mutation = mutation();
          }

          return React.createElement(
            Mutation,
            (0, _extends3.default)({ mutation: mutation }, other, {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 165
              }
            }),
            function (mutate, mutationResult) {
              var resultProps = void 0;
              if (mapResultToProps) {
                resultProps = mapResultToProps(mutate, mutationResult);
              } else {
                var document = mutation;
                var operationName = '';
                if (document && document.definitions[0]) {
                  operationName = document.definitions[0].name.value;
                }
                var mutatePropName = operationName || 'mutate';

                _this4._mutate = mutate;

                resultProps = (0, _defineProperty3.default)({}, mutatePropName, _this4.mutate);
              }

              return React.createElement(WrappedComponent, (0, _extends3.default)({}, _this4.props, resultProps, {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 186
                }
              }));
            }
          );
        }
      }]);
      return WithMutation;
    }(React.PureComponent);

    WithMutation.displayName = 'WithMutation(' + getComponentDisplayName(WrappedComponent) + ')';
    WithMutation.contextTypes = {
      app: PropTypes.object
    };

    var _initialiseProps = function _initialiseProps() {
      var _this5 = this;

      this.mutate = function () {
        return _this5._mutate.apply(_this5, arguments);
      };
    };

    hoistNonReactStatics(WithMutation, WrappedComponent);
    return WithMutation;
  };
};