'use strict';

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('../../server/next-plus'),
    addServerModule = _require.addServerModule;

var fs = require('fs-extra');

var _require2 = require('path'),
    join = _require2.join;

var _require3 = require('../utils/mongodb-prebuilt'),
    MongodHelper = _require3.MongodHelper;

addServerModule('defaultMongoDevServerModule', {
  setup: function setup(_ref) {
    var _ref$dir = _ref.dir,
        dir = _ref$dir === undefined ? '.' : _ref$dir;

    if (typeof this.dir === 'undefined') {
      this.dir = dir;
    }
  },
  beforeStartup: function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
      var appName, mongoPort, dbPath;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(process.env.MONGO_URL !== 'test')) {
                _context.next = 4;
                break;
              }

              if (!process.env.MONGO_URL) {
                _context.next = 4;
                break;
              }

              console.log('> MONGO_URL defined, mongo dev server not start!', process.env.MONGO_URL);
              return _context.abrupt('return');

            case 4:
              appName = 'next';
              mongoPort = process.env.MONGO_PORT || 3001;

              process.env.MONGO_URL = 'mongodb://127.0.0.1:' + mongoPort + '/' + appName;
              console.log('> MONGO_URL: mongodb://127.0.0.1:' + mongoPort + '/' + appName);
              dbPath = join(this.dir, '.next', 'db');
              _context.prev = 9;

              fs.ensureDirSync(dbPath);
              _context.next = 16;
              break;

            case 13:
              _context.prev = 13;
              _context.t0 = _context['catch'](9);
              throw _context.t0;

            case 16:

              this.mongodHelper = new MongodHelper(['--port', '' + mongoPort, '--dbpath', dbPath]);
              _context.prev = 17;
              _context.next = 20;
              return this.mongodHelper.run();

            case 20:
              console.log('> mongod is running');
              _context.next = 27;
              break;

            case 23:
              _context.prev = 23;
              _context.t1 = _context['catch'](17);

              console.log('> error starting', _context.t1);
              throw _context.t1;

            case 27:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this, [[9, 13], [17, 23]]);
    }));

    function beforeStartup() {
      return _ref2.apply(this, arguments);
    }

    return beforeStartup;
  }(),
  afterStartup: function afterStartup() {
    var _this = this;

    var server = this;
    this.onClose((0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (!server.mongodHelper) {
                _context2.next = 4;
                break;
              }

              server.mongodHelper.mongoBin.childProcess.kill();
              _context2.next = 4;
              return new _promise2.default(function (resolve) {
                server.mongodHelper.mongoBin.childProcess.on('close', function () {
                  resolve();
                });
              });

            case 4:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, _this);
    })));
  }
});