'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _jsxFileName = 'client.js';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var merge = require('lodash/merge');
var React = require('react');
var PropTypes = require('prop-types');

var _require = require('react-apollo'),
    Query = _require.Query;

var hoistNonReactStatics = require('hoist-non-react-statics');

var _require2 = require('../utils'),
    getComponentDisplayName = _require2.getComponentDisplayName;

var NextClient = require('../../app/next-plus');

var common = require('./common');

NextClient.addAppModule('defaultSettingsModule', {
  setup: function setup() {
    common(this);
  }
});

var QueryAppSettings = function (_React$Component) {
  (0, _inherits3.default)(QueryAppSettings, _React$Component);

  function QueryAppSettings() {
    (0, _classCallCheck3.default)(this, QueryAppSettings);
    return (0, _possibleConstructorReturn3.default)(this, (QueryAppSettings.__proto__ || (0, _getPrototypeOf2.default)(QueryAppSettings)).apply(this, arguments));
  }

  (0, _createClass3.default)(QueryAppSettings, [{
    key: 'render',
    value: function render() {
      var children = this.props.children;
      var _context$app = this.context.app,
          ssr = _context$app.ssr,
          getQuery = _context$app.getQuery,
          settings = _context$app.settings;


      return React.createElement(
        Query,
        {
          query: getQuery('appSettings'),
          fetchPolicy: ssr ? 'cache-first' : 'network-only',
          __source: {
            fileName: _jsxFileName,
            lineNumber: 28
          }
        },
        function (queryResult) {
          var appSettings = queryResult.data.appSettings;
          if (appSettings) {
            merge(settings, { public: (0, _extends3.default)({}, appSettings) });
          }
          return children(queryResult);
        }
      );
    }
  }]);
  return QueryAppSettings;
}(React.Component);

QueryAppSettings.contextTypes = {
  app: PropTypes.object
};

NextClient.QueryAppSettings = QueryAppSettings;

NextClient.withAppSettings = function (WrappedComponent) {
  var WithAppSettings = function (_React$PureComponent) {
    (0, _inherits3.default)(WithAppSettings, _React$PureComponent);

    function WithAppSettings() {
      (0, _classCallCheck3.default)(this, WithAppSettings);
      return (0, _possibleConstructorReturn3.default)(this, (WithAppSettings.__proto__ || (0, _getPrototypeOf2.default)(WithAppSettings)).apply(this, arguments));
    }

    (0, _createClass3.default)(WithAppSettings, [{
      key: 'render',
      value: function render() {
        var _this3 = this;

        var settings = this.context.app.settings;


        return React.createElement(
          QueryAppSettings,
          {
            __source: {
              fileName: _jsxFileName,
              lineNumber: 57
            }
          },
          function (_ref) {
            var loading = _ref.loading,
                error = _ref.error,
                data = _ref.data;
            return React.createElement(WrappedComponent, (0, _extends3.default)({}, _this3.props, {
              appSettings: data.appSettings || {},
              settings: settings || { public: {} },
              __source: {
                fileName: _jsxFileName,
                lineNumber: 59
              }
            }));
          }
        );
      }
    }]);
    return WithAppSettings;
  }(React.PureComponent);

  WithAppSettings.displayName = 'WithAppSettings(' + getComponentDisplayName(WrappedComponent) + ')';
  WithAppSettings.contextTypes = {
    app: PropTypes.object
  };

  hoistNonReactStatics(WithAppSettings, WrappedComponent);
  return WithAppSettings;
};