'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var merge = require('lodash/merge');
var omit = require('lodash/omit');

var _require = require('../../server/next-plus'),
    addServerModule = _require.addServerModule;

var common = require('./common');

addServerModule('defaultSettingsModule', {
  setup: function setup() {
    common(this);
  },
  beforeStartup: function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
      var Settings, settings;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              Settings = this.createCollection('Settings');

              if (!process.env.MONGO_URL) {
                _context.next = 6;
                break;
              }

              _context.next = 4;
              return Settings.findOne();

            case 4:
              settings = _context.sent;

              if (settings) {
                merge(this.settings, omit(settings, 'appSettings', '_id'));
              }

            case 6:

              try {
                if (this.getSetting('mailUrl') && !process.env.MAIL_URL) {
                  process.env.MAIL_URL = this.getSetting('mailUrl');
                  delete this.settings.public.mailUrl;
                }
              } catch (__) {}

              if (process.env.ROOT_URL) {
                this.settings.public.rootUrl = process.env.ROOT_URL;
              }

            case 8:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function beforeStartup() {
      return _ref.apply(this, arguments);
    }

    return beforeStartup;
  }(),
  schemaStartup: function schemaStartup() {
    this.addGraphqlQueryField('appSettings: JSON');
    this.addGraphqlResolvers({
      Query: {
        appSettings: function () {
          var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(root, args, context) {
            var _context$server$getCo, Settings, settings;

            return _regenerator2.default.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    _context$server$getCo = context.server.getCollections(), Settings = _context$server$getCo.Settings;
                    _context2.next = 3;
                    return Settings.findOne({}, { fields: { appSettings: 1 } });

                  case 3:
                    settings = _context2.sent;
                    return _context2.abrupt('return', settings && settings.appSettings || {});

                  case 5:
                  case 'end':
                    return _context2.stop();
                }
              }
            }, _callee2, this);
          }));

          function appSettings(_x, _x2, _x3) {
            return _ref2.apply(this, arguments);
          }

          return appSettings;
        }()
      }
    });
  }
});