'use strict';

var _create = require('babel-runtime/core-js/object/create');

var _create2 = _interopRequireDefault(_create);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// meteor/packages/localstorage/localstorage.js
// c360e51fe0fe8f4da995e4ead07b3a9a4f97e093

var _require = require('../common'),
    isServer = _require.isServer,
    isClient = _require.isClient,
    debug = _require.debug;

var _require2 = require('../random'),
    Random = _require2.Random;

// Meteor._localStorage is not an ideal name, but we can change it later.

// Let's test to make sure that localStorage actually works. For example, in
// Safari with private browsing on, window.localStorage exists but actually
// trying to use it throws.
// Accessing window.localStorage can also immediately throw an error in IE (#1291).

var hasOwn = Object.prototype.hasOwnProperty;
var key = '_localstorage_test_' + Random.id();
var retrieved;
var storage;

var LocalStorage = void 0;

try {
  storage = global.localStorage;

  if (storage) {
    storage.setItem(key, key);
    retrieved = storage.getItem(key);
    storage.removeItem(key);
  }
} catch (ignored) {}

if (key === retrieved) {
  if (isServer) {
    LocalStorage = storage;
  } else {
    // Some browsers (e.g. IE11) don't properly handle attempts to change
    // window.localStorage methods. By using proxy methods to expose
    // window.localStorage functionality, developers can change the
    // behavior of Meteor._localStorage methods without breaking
    // window.localStorage.
    ;['getItem', 'setItem', 'removeItem'].forEach(function (name) {
      this[name] = function () {
        return storage[name].apply(storage, arguments);
      };
    }, LocalStorage = {});
  }
}

if (!LocalStorage) {
  if (isClient) {
    debug('You are running a browser with no localStorage or userData ' + 'support. Logging in from one tab will not cause another ' + 'tab to be logged in.');
  }

  LocalStorage = (0, _create2.default)({
    setItem: function setItem(key, val) {
      this[key] = val;
    },

    removeItem: function removeItem(key) {
      delete this[key];
    },

    getItem: function getItem(key) {
      return hasOwn.call(this, key) ? this[key] : null;
    }
  });
}

module.exports = {
  LocalStorage: LocalStorage
};