'use strict';

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('../ejson'),
    EJSON = _require.EJSON;

var _require2 = require('../tracker'),
    Tracker = _require2.Tracker;

var _require3 = require('../mongo-id'),
    MongoID = _require3.MongoID;

var _require4 = require('../id-map'),
    IdMap = _require4.IdMap;

var hasOwn = Object.prototype.hasOwnProperty;

var _IdMap = function (_IdMap2) {
  (0, _inherits3.default)(_IdMap, _IdMap2);

  function _IdMap() {
    (0, _classCallCheck3.default)(this, _IdMap);
    return (0, _possibleConstructorReturn3.default)(this, (_IdMap.__proto__ || (0, _getPrototypeOf2.default)(_IdMap)).call(this, MongoID.idStringify, MongoID.idParse));
  }

  return _IdMap;
}(IdMap);

var wrapTransform = function wrapTransform(transform) {
  if (!transform) {
    return null;
  }

  // No need to doubly-wrap transforms.
  if (transform.__wrappedTransform__) {
    return transform;
  }

  var wrapped = function wrapped(doc) {
    if (!hasOwn.call(doc, '_id')) {
      // XXX do we ever have a transform on the oplog's collection? because that
      // collection has no _id.
      throw new Error('can only transform documents with _id');
    }

    var id = doc._id;

    // XXX consider making tracker a weak dependency and checking
    // Package.tracker here
    var transformed = Tracker.nonreactive(function () {
      return transform(doc);
    });

    if (!_isPlainObject(transformed)) {
      throw new Error('transform must return object');
    }

    if (hasOwn.call(transformed, '_id')) {
      if (!EJSON.equals(transformed._id, id)) {
        throw new Error("transformed document can't have different _id");
      }
    } else {
      transformed._id = id;
    }

    return transformed;
  };

  wrapped.__wrappedTransform__ = true;

  return wrapped;
};

var _isModificationMod = function _isModificationMod(mod) {
  var isModify = false;
  var isReplace = false;

  (0, _keys2.default)(mod).forEach(function (key) {
    if (key.substr(0, 1) === '$') {
      isModify = true;
    } else {
      isReplace = true;
    }
  });

  if (isModify && isReplace) {
    throw new Error('Update parameter cannot have both modifier and non-modifier fields.');
  }

  return isModify;
};

var _isPlainObject = function _isPlainObject(x) {
  return x && _f._type(x) === 3;
};

var _selectorIsId = function _selectorIsId(selector) {
  return typeof selector === 'number' || typeof selector === 'string' || selector instanceof MongoID.ObjectID;
};

var _f = {
  // XXX for _all and _in, consider building 'inquery' at compile time..
  _type: function _type(v) {
    if (typeof v === 'number') {
      return 1;
    }

    if (typeof v === 'string') {
      return 2;
    }

    if (typeof v === 'boolean') {
      return 8;
    }

    if (Array.isArray(v)) {
      return 4;
    }

    if (v === null) {
      return 10;
    }

    // note that typeof(/x/) === "object"
    if (v instanceof RegExp) {
      return 11;
    }

    if (typeof v === 'function') {
      return 13;
    }

    if (v instanceof Date) {
      return 9;
    }

    if (EJSON.isBinary(v)) {
      return 5;
    }

    if (v instanceof MongoID.ObjectID) {
      return 7;
    }

    // object
    return 3;

    // XXX support some/all of these:
    // 14, symbol
    // 15, javascript code with scope
    // 16, 18: 32-bit/64-bit integer
    // 17, timestamp
    // 255, minkey
    // 127, maxkey
  }
};

module.exports = {
  _IdMap: _IdMap,
  wrapTransform: wrapTransform,
  _isModificationMod: _isModificationMod,
  _isPlainObject: _isPlainObject,
  _selectorIsId: _selectorIsId,
  _f: _f
};