'use strict';

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MongoDBPrebuilt = require('./mongodb-prebuilt');
var MongoSupervise = require('./mongodb-supervise');

var resolvePath = require('path').resolve;
var spawnChild = require('child_process').spawn;

module.exports = function () {
  function MongoBins(command) {
    var commandArguments = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    var spawnOptions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    (0, _classCallCheck3.default)(this, MongoBins);

    this.command = command;
    this.mongoDBPrebuilt = new MongoDBPrebuilt();
    this.commandArguments = commandArguments;
    this.spawnOptions = spawnOptions;
  }

  (0, _createClass3.default)(MongoBins, [{
    key: 'run',
    value: function run() {
      var _this = this;

      return new _promise2.default(function (resolve, reject) {
        _this.runCommand().then(function () {
          _this.mongoSupervice = new MongoSupervise(_this.childProcess.pid);
          _this.mongoSupervice.run().then(function () {
            // all good
          }, function (e) {
            // didnt start
            console.log('run() Supervise process didn\'t start: ' + e, e);
          });
          resolve(true);
        }, function (e) {
          console.log('error executing command ' + e);
          reject(e);
        });
      });
    }
  }, {
    key: 'runCommand',
    value: function runCommand() {
      var _this2 = this;

      return new _promise2.default(function (resolve, reject) {
        var getCommandPromise = _this2.getCommand();
        var getCommandArgumentsPromise = _this2.getCommandArguments();

        _promise2.default.all([getCommandPromise, getCommandArgumentsPromise]).then(function (promiseValues) {
          var command = promiseValues[0];
          var commandArguments = promiseValues[1];
          _this2.childProcess = spawnChild(command, commandArguments, _this2.spawnOptions);
          _this2.childProcess.on('close', function () {
            if (_this2.mongoSupervice && _this2.mongoSupervice.monitorChild) {
              _this2.mongoSupervice.monitorChild.kill();
            }
          });
          _this2.childProcess.on('exit', function () {
            console.log('mongo-bins childPross on exit!!!');
          });
          _this2.childProcess.on('SIGINT', function () {
            console.log('mongo-bins childPross on SIGINT!!!');
          });
          _this2.childProcess.on('SIGTERM', function () {
            console.log('mongo-bins childPross on SIGTERM!!!');
          });
          resolve(true);
        });
      });
    }
  }, {
    key: 'getCommand',
    value: function getCommand() {
      var _this3 = this;

      return new _promise2.default(function (resolve, reject) {
        _this3.mongoDBPrebuilt.getBinPath().then(function (binPath) {
          var command = resolvePath(binPath, _this3.command);
          resolve(command);
        });
      });
    }
  }, {
    key: 'getCommandArguments',
    value: function getCommandArguments() {
      var _this4 = this;

      return new _promise2.default(function (resolve, reject) {
        resolve(_this4.commandArguments);
      });
    }
  }]);
  return MongoBins;
}();