'use strict';

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MongoDBDownload = require('./mongodb-download');

var resolvePath = require('path').resolve;
var osHomeDir = require('os').homedir;
var glob = require('glob');

module.exports = function () {
  function MongoDBPrebuilt(mongoDBDownload) {
    (0, _classCallCheck3.default)(this, MongoDBPrebuilt);

    this.mongoDBDownload = mongoDBDownload;

    if (this.mongoDBDownload === undefined) {
      this.mongoDBDownload = new MongoDBDownload({
        downloadDir: this.getHomeDirectory()
      });
    }
  }

  (0, _createClass3.default)(MongoDBPrebuilt, [{
    key: 'getHomeDirectory',
    value: function getHomeDirectory() {
      var homeDir = resolvePath(osHomeDir(), '.next');
      return homeDir;
    }
  }, {
    key: 'getBinPath',
    value: function getBinPath() {
      var _this = this;

      return new _promise2.default(function (resolve, reject) {
        if (_this.binPath !== undefined) {
          return resolve(_this.binPath);
        }
        _this.mongoDBDownload.downloadAndExtract().then(function (extractLocation) {
          _this.resolveBinPath(extractLocation).then(function (binPath) {
            resolve(binPath);
          }, function (e) {
            reject(e);
          });
        });
      });
    }
  }, {
    key: 'resolveBinPath',
    value: function resolveBinPath(extractLocation) {
      var _this2 = this;

      return new _promise2.default(function (resolve, reject) {
        var binPath = extractLocation + '/*/bin';
        glob(binPath, {}, function (err, files) {
          if (err) {
            console.log('resolveBinPath() error ' + err);
            reject(err);
          } else {
            if (_this2.hasValidBinPath(files) === true) {
              var resolvedBinPath = files[0];
              resolve(resolvedBinPath);
            } else {
              reject(new Error('path not found'));
            }
          }
        });
      });
    }
  }, {
    key: 'hasValidBinPath',
    value: function hasValidBinPath(files) {
      if (files.length === 1) {
        return true;
      } else if (files.length > 1) {
        console.log('getBinPath() directory corrupted, only one installation per hash can exist');
        return false;
      } else {
        console.log('getBinPath() doesn\'t exist, files: ' + files);
        return false;
      }
    }
  }]);
  return MongoDBPrebuilt;
}();