'use strict';

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var resolvePath = require('path').resolve;
var spawnChild = require('child_process').spawn;

module.exports = function () {
  function MongoSupervise(childPid) {
    (0, _classCallCheck3.default)(this, MongoSupervise);

    this.childPid = childPid;
    this.execPath = resolvePath(__dirname, '..', '..', '..', 'bin');
    this.parentPid = process.pid;
    this.command = 'mongo-supervise';
    this.platform = process.platform;
  }

  (0, _createClass3.default)(MongoSupervise, [{
    key: 'getSuperviseCommand',
    value: function getSuperviseCommand() {
      var killerCommand = resolvePath(this.execPath, this.command);
      return killerCommand;
    }
  }, {
    key: 'run',
    value: function run() {
      var _this = this;

      return new _promise2.default(function (resolve, reject) {
        if (_this.isWindows() === true) {
          _this.runOnWindows();
        } else {
          _this.runOnLinux();
        }

        _this.monitorChild.on('close', function (code) {
          // console.log('close of monitor child', code);
        });

        resolve(true);
      });
    }
  }, {
    key: 'isWindows',
    value: function isWindows() {
      var isWindows = this.platform === 'win32';
      return isWindows;
    }
  }, {
    key: 'runOnWindows',
    value: function runOnWindows() {
      var command = this.getSuperviseCommand();
      this.monitorChild = spawnChild('cmd.exe', [command, this.parentPid.toString(), this.childPid.toString()]);
    }
  }, {
    key: 'runOnLinux',
    value: function runOnLinux() {
      var command = this.getSuperviseCommand();
      this.monitorChild = spawnChild(command, [this.parentPid.toString(), this.childPid.toString()]);
    }
  }]);
  return MongoSupervise;
}();