'use strict';

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// meteor/packages/url/url_client.js
// 80e564e9c31fa819905c7cfe5bc64a93446259da

/* eslint-disable camelcase */

var URL = {};

function encodeString(str) {
  return encodeURIComponent(str).replace(/\*/g, '%2A');
}

// Encode URL paramaters into a query string, handling nested objects and
// arrays properly.
URL._encodeParams = function (params, prefix) {
  var str = [];
  var isParamsArray = Array.isArray(params);
  for (var p in params) {
    if (Object.prototype.hasOwnProperty.call(params, p)) {
      var k = prefix ? prefix + '[' + (isParamsArray ? '' : p) + ']' : p;
      var v = params[p];
      if ((typeof v === 'undefined' ? 'undefined' : (0, _typeof3.default)(v)) === 'object') {
        str.push(this._encodeParams(v, k));
      } else {
        var encodedKey = encodeString(k).replace('%5B', '[').replace('%5D', ']');
        str.push(encodedKey + '=' + encodeString(v));
      }
    }
  }
  return str.join('&').replace(/%20/g, '+');
};

var buildUrl = function buildUrl(before_qmark, from_qmark, opt_query, opt_params) {
  var url_without_query = before_qmark;
  var query = from_qmark ? from_qmark.slice(1) : null;

  if (typeof opt_query === 'string') {
    query = String(opt_query);
  }

  if (opt_params) {
    query = query || '';
    var prms = URL._encodeParams(opt_params);
    if (query && prms) {
      query += '&';
    }
    query += prms;
  }

  var url = url_without_query;
  if (query !== null) {
    url += '?' + query;
  }

  return url;
};

URL._constructUrl = function (url, query, params) {
  var query_match = /^(.*?)(\?.*)?$/.exec(url);
  return buildUrl(query_match[1], query_match[2], query, params);
};

module.exports = {
  URL: URL
};