'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var express = require('express');
var cookieParser = require('cookie-parser');
var next = require('next');

var _require = require('../../server/next-plus'),
    addServerModule = _require.addServerModule;

var _require2 = require('../utils'),
    COOKIES_LOGIN_TOKEN_KEY = _require2.COOKIES_LOGIN_TOKEN_KEY,
    debug = _require2.debug;

addServerModule('defaultWebAppModule', {
  setup: function setup(_ref) {
    var _ref$dir = _ref.dir,
        dir = _ref$dir === undefined ? '.' : _ref$dir,
        _ref$conf = _ref.conf,
        conf = _ref$conf === undefined ? { distDir: '.next/build' } : _ref$conf,
        app = _ref.app;

    this.dir = dir;
    this.appHandlers = express();
    if (app === null || app) {
      this._appDefined = true;
      this.app = app;
    } else {
      this.app = next({ dir: this.dir, dev: this.dev, conf: conf });
    }
  },
  startup: function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
      var server, handle;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              server = this;


              server.handleRequest.use(cookieParser());

              server.handleRequest.use(function () {
                var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(req, res, next) {
                  var currentUser, loginToken;
                  return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          req.server = server;

                          if (!(req.url.indexOf('/graphql') === 0 || req.url.indexOf('/_') === 0)) {
                            _context.next = 4;
                            break;
                          }

                          next();
                          return _context.abrupt('return');

                        case 4:
                          currentUser = null;
                          loginToken = req.cookies && req.cookies[COOKIES_LOGIN_TOKEN_KEY];

                          if (!(loginToken && server.getUserFromToken)) {
                            _context.next = 10;
                            break;
                          }

                          _context.next = 9;
                          return server.getUserFromToken(loginToken);

                        case 9:
                          currentUser = _context.sent;

                        case 10:
                          req.currentUser = currentUser;
                          next();

                        case 12:
                        case 'end':
                          return _context.stop();
                      }
                    }
                  }, _callee, this);
                }));

                function rootMiddleware(_x, _x2, _x3) {
                  return _ref3.apply(this, arguments);
                }

                return rootMiddleware;
              }());

              server.handleRequest.use(function appHandlersMiddleware(req, res, next) {
                if (req.url.indexOf('/_next') === 0) {
                  next();
                } else {
                  server.appHandlers(req, res, next);
                }
              });

              server.handleRequest.use(function errorMiddleware(err, req, res, next) {
                if (!err) {
                  next(err);
                  return;
                }
                debug('Exception in request handle:', err && err.stack || err);
                res.writeHead(err.status || 500, { 'Content-Type': 'text/plain' });
                res.end('An error message');
              });

              if (server._appDefined) {
                _context2.next = 10;
                break;
              }

              _context2.next = 8;
              return server.app.prepare();

            case 8:
              handle = server.app.getRequestHandler();

              server.handleRequest.get('*', function nextAppMiddleware(req, res) {
                return handle(req, res);
              });

            case 10:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function startup() {
      return _ref2.apply(this, arguments);
    }

    return startup;
  }()
});