'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

// run all startup hooks
var runStartupHooks = function () {
  var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(server, type) {
    var startupModules, i, startupModule;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            // get all startup hooks from modules objects
            startupModules = filter(server.modules, type);

            console.log('server#' + server.id + '> server ' + type + ', total: ' + startupModules.length);
            i = 1;

          case 3:
            if (!startupModules.length) {
              _context5.next = 16;
              break;
            }

            startupModule = startupModules.shift();

            console.log('server#' + server.id + '> ' + i++ + ': ' + (startupModule.name || '[no name]') + ' ' + type);
            _context5.prev = 6;
            _context5.next = 9;
            return startupModule[type].call(server);

          case 9:
            _context5.next = 14;
            break;

          case 11:
            _context5.prev = 11;
            _context5.t0 = _context5['catch'](6);

            _debug('Exception in server ' + type + ':', _context5.t0 && _context5.t0.stack || _context5.t0);

          case 14:
            _context5.next = 3;
            break;

          case 16:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this, [[6, 11]]);
  }));

  return function runStartupHooks(_x5, _x6) {
    return _ref5.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var http = require('http');
var express = require('express');
var filter = require('lodash/filter');
var merge = require('lodash/merge');

var _require = require('../lib/utils'),
    _debug = _require.debug,
    bindAndCatch = _require.bindAndCatch,
    Hook = _require.Hook;

// server class


module.exports = function () {
  function Server() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck3.default)(this, Server);

    // options.dev
    options.dev = options.dev || false;
    // options.settings
    options.settings = options.settings || {};
    // options.modules
    options.modules = options.modules || [];

    // set default values
    this.dev = options.dev;
    this.settings = options.settings;
    this.settings.public = this.settings.public || {};
    this.modules = options.modules;

    // request middleware
    this.handleRequest = express();
    // server id
    this.id = Date.now().toString();

    // close hooks run when server close
    this._onCloseHook = new Hook();

    // run all setup hooks
    runSetupHooks(this, options);
  }

  // get request middleware


  (0, _createClass3.default)(Server, [{
    key: 'getRequestHandler',
    value: function getRequestHandler() {
      return this.handleRequest;
    }

    // prepare and run all startup hooks

  }, {
    key: 'prepare',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return runStartupHooks(this, 'beforeStartup');

              case 2:
                _context.next = 4;
                return runStartupHooks(this, 'startup');

              case 4:
                _context.next = 6;
                return runStartupHooks(this, 'schemaStartup');

              case 6:
                _context.next = 8;
                return runStartupHooks(this, 'afterStartup');

              case 8:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function prepare() {
        return _ref.apply(this, arguments);
      }

      return prepare;
    }()

    // close server

  }, {
    key: 'close',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        var _this = this;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this._onCloseHook.eachAsync(function () {
                  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(callback) {
                    return _regenerator2.default.wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            _context2.next = 2;
                            return callback();

                          case 2:
                            return _context2.abrupt('return', true);

                          case 3:
                          case 'end':
                            return _context2.stop();
                        }
                      }
                    }, _callee2, _this);
                  }));

                  return function (_x2) {
                    return _ref3.apply(this, arguments);
                  };
                }());

              case 2:
                if (!this.http) {
                  _context3.next = 5;
                  break;
                }

                _context3.next = 5;
                return new _promise2.default(function (resolve, reject) {
                  _this.http.close(bindAndCatch(function (err) {
                    if (err) return reject(err);
                    return resolve();
                  }));
                });

              case 5:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function close() {
        return _ref2.apply(this, arguments);
      }

      return close;
    }()

    // register on close hooks

  }, {
    key: 'onClose',
    value: function onClose(func) {
      return this._onCloseHook.register(func);
    }
  }, {
    key: 'onStartServer',
    value: function onStartServer(func) {
      if (this._onStartServerHook) {
        throw new Error('Can only call onStartServer once');
      }

      this._onStartServerHook = func;
    }

    // server start

  }, {
    key: 'start',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(port, hostname) {
        var _this2 = this;

        var httpServer;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this.prepare();

              case 2:
                // 2. create http server
                this.http = http.createServer(this.getRequestHandler());

                if (!this._onStartServerHook) {
                  _context4.next = 12;
                  break;
                }

                _context4.next = 6;
                return this._onStartServerHook(this.http, {
                  port: port,
                  hostname: hostname,
                  server: this
                });

              case 6:
                httpServer = _context4.sent;

                if (!httpServer) {
                  _context4.next = 11;
                  break;
                }

                this.http = httpServer;
                _context4.next = 12;
                break;

              case 11:
                return _context4.abrupt('return');

              case 12:
                _context4.next = 14;
                return new _promise2.default(function (resolve, reject) {
                  // This code catches EADDRINUSE error if the port is already in use
                  _this2.http.on('error', reject);
                  _this2.http.on('listening', function () {
                    return resolve();
                  });
                  _this2.http.listen(port, hostname);
                });

              case 14:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function start(_x3, _x4) {
        return _ref4.apply(this, arguments);
      }

      return start;
    }()

    // get settings

  }, {
    key: 'getSetting',
    value: function getSetting(name, defaultValue) {
      var settings = this.settings;

      var rootSetting = settings[name];
      var privateSetting = settings.private && settings.private[name];
      var publicSetting = settings.public && settings.public[name];

      if ((typeof rootSetting === 'undefined' ? 'undefined' : (0, _typeof3.default)(rootSetting)) === 'object' && !Array.isArray(rootSetting) || (typeof privateSetting === 'undefined' ? 'undefined' : (0, _typeof3.default)(privateSetting)) === 'object' && !Array.isArray(privateSetting) || (typeof publicSetting === 'undefined' ? 'undefined' : (0, _typeof3.default)(publicSetting)) === 'object' && !Array.isArray(publicSetting)) {
        return merge({}, defaultValue, publicSetting, rootSetting, privateSetting);
      } else {
        if (privateSetting !== undefined) return privateSetting;else if (rootSetting !== undefined) return rootSetting;else if (publicSetting !== undefined) return publicSetting;
        return defaultValue;
      }
    }

    // get url

  }, {
    key: 'absoluteUrl',
    value: function absoluteUrl(path, options) {
      // path is optional
      if (!options && (typeof path === 'undefined' ? 'undefined' : (0, _typeof3.default)(path)) === 'object') {
        options = path;
        path = undefined;
      }
      // merge options with defaults
      options = options || {};
      options = (0, _extends3.default)({
        rootUrl: this.getSetting('rootUrl')
      }, options);

      var url = options.rootUrl;
      if (!url) {
        throw new Error('Must pass options.rootUrl or set rootUrl in the settings');
      }

      if (!/^http[s]?:\/\//i.test(url)) {
        // url starts with 'http://' or 'https://'
        url = 'http://' + url; // we will later fix to https if options.secure is set
      }

      if (!/\/$/.test(url)) {
        // url ends with '/'
        url += '/';
      }

      if (path) {
        url += path;
      }

      // turn http to https if secure option is set, and we're not talking
      // to localhost.
      if (options.secure && /^http:/.test(url) && // url starts with 'http:'
      !/http:\/\/localhost[:/]/.test(url) && // doesn't match localhost
      !/http:\/\/127\.0\.0\.1[:/]/.test(url)) {
        // or 127.0.0.1
        url = url.replace(/^http:/, 'https:');
      }

      if (options.replaceLocalhost) {
        url = url.replace(/^http:\/\/localhost([:/].*)/, 'http://127.0.0.1$1');
      }

      return url;
    }

    // use for capture exception

  }, {
    key: 'captureException',
    value: function captureException(e) {
      this.debug('capture exception', e);
    }

    // debug logger

  }, {
    key: 'debug',
    value: function debug() {
      if (this.dev && this.getSetting('debug')) {
        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _debug.apply(undefined, ['DEBUG>'].concat(args));
      }
    }
  }]);
  return Server;
}();

// ran all setup hooks
function runSetupHooks(server, options) {
  // get all setup hooks from modules objects
  var setupModules = filter(server.modules, 'setup');
  console.log('server#' + server.id + '> server setup, total: ' + setupModules.length);
  var i = 1;
  while (setupModules.length) {
    var setupModule = setupModules.shift();
    console.log('server#' + server.id + '> ' + i++ + ': ' + (setupModule.name || '[no name]') + ' setup');
    try {
      // run setup module
      // setup module cannot be async function
      // use startup to run async function
      var ret = setupModule.setup.call(server, options);
      if (ret instanceof _promise2.default || ret && ret.then) {
        ret.catch(function (e) {});
        throw new Error('The setup function cannot be async, use startup to run async function. Setup: ' + setupModule.setup);
      }
    } catch (error) {
      _debug('Exception in server setup:', error && error.stack || error);
    }
  }
}