'use strict';

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

global.crypto = require('crypto');

var map = require('lodash/map');
var Server = require('./');

var NextServer = (0, _extends3.default)({}, require('../lib/utils'), require('../lib/utils/email'), require('../lib/utils/http/server'), require('../lib/utils/mongo'), require('../lib/utils/url/server'));
global.Next = global.NextServer = NextServer;

NextServer.createServer = function () {
  var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var modules = opts.modules;
  if (modules && !Array.isArray(modules)) {
    modules = map(modules, function (mod, name) {
      if (!mod.name) mod.name = name;
      return mod;
    });
  }
  opts.modules = [].concat((0, _toConsumableArray3.default)(NextServer.serverModules), (0, _toConsumableArray3.default)(modules || []));

  return new Server(opts);
};

NextServer.serverModules = [];
NextServer.addServerModule = function (name, obj) {
  if ((typeof name === 'undefined' ? 'undefined' : (0, _typeof3.default)(name)) === 'object') {
    obj = name;
    name = undefined;
  }
  if (name && typeof name === 'string') {
    obj.name = name;
  }
  NextServer.serverModules.push(obj);
};

module.exports = NextServer;